/*
 * CasinoAgent.java
 *
 * Created on 11. Juni 2002, 11:02
 */

package casino.agents;
import lime.*;
import lights.adapters.*;
import lights.interfaces.*;
import java.io.*;
import casino.plugins.decision.*; 
import casino.plugins.*;
import casino.misc.*;
import casino.plugins.lookup.*;
import casino.plugins.lookup.basic.*;
import casino.plugins.lookup.version1_0.*;
import casino.migration.*;

/**
 *
 * @author  marcel 
 * @version 1.0
 */

public class CasinoAgent extends lime.StationaryAgent {
    
		protected long ID = -1;
		protected LimeTupleSpace lts = null;
		protected boolean running = true;
		protected int decisionVersion = 0; // = PluginID
		protected casino.plugins.Plugin decision = null;
		protected boolean leader = false;
		protected boolean leaderSet = false;
                protected AgentLocation agentL = null;
                protected HostLocation hostL = null;
                protected HostLocation destinationHost = null;
    /** Creates new CasinoAgent */
    public CasinoAgent() {
        super();
    }
    
        //setzen, ob Agent Spielleiter oder nicht
	public void setLeader(boolean flag) {
		leader = flag;
		leaderSet = true;
	}

	public LimeServer getLimeServer() {
		return LimeServer.getServer();
	}

	public void run() {
                //LimeServer.getServer().declareLeader();
		// Initialize PluginBoard access
		while(!leaderSet){
			try {
				sleep(100L);
			} catch(InterruptedException e) { e.printStackTrace(); }
		}
		try {
			lts = new LimeTupleSpace(CommonPluginTerms.PLUGINBOARD_TS_VERSION_1_0);
			lts.setShared(true);
                        LimeServer.getServer().engage();
                        showMessage("TS shared: "+lts.isShared());

			showMessage("CA: Connected to PluginBoard "+LimeServer.getServer().isEngaged());
                        
                        try{
                            ITuple tuple = new Tuple();
                            tuple.addActual(new String("ADMINLOC"));
                            tuple.addFormal(AgentLocation.class);
                            ITuple result = lts.rd(tuple);
                            
                            agentL = (AgentLocation) result.get(1).getValue();
                            showMessage("Admin-Location: "+agentL);
                        }catch(Exception e){e.printStackTrace();}
                        try{
                            ITuple tuple = new Tuple();
                            tuple.addActual(new String("HOSTLOC"));
                            tuple.addFormal(HostLocation.class);
                            ITuple result = lts.rd(tuple);
                            hostL = (HostLocation) result.get(1).getValue();
                            showMessage("Host-Location: "+hostL);
                        }catch(Exception e){e.printStackTrace();}
                        lts.in((new MigrationToken()).free());
			// Now get the DecisionPlugin from the PluginBoard
			ITuple decisionTemplate = new Tuple();
			if(leader) {
				decisionTemplate.addActual(casino.plugins.CommonPluginTerms.LEADER_DECISION_PLUGIN);
			} else {
				decisionTemplate.addActual(casino.plugins.CommonPluginTerms.PLAYER_DECISION_PLUGIN);
			}		
			decisionTemplate.addActual(new Double(0));
			decisionTemplate.addFormal(PluginContainer.class);

			ITuple decisionRead = lts.rd(decisionTemplate);
			showMessage("CA: Received DecisionPlugIn");
			PluginContainer container = (PluginContainer) decisionRead.get(2).getValue();		
			decision = container.getPlugin();
                        DecisionPlugIn dec = (DecisionPlugIn)decision;
                        dec.setAgent(this);
                        dec.setOpQueue(new OpQueue(lts));
			dec.activate();
                        lts.out(agentL,(new MigrationToken()).free());
			showMessage("CA: DecisionComponent initialized: Now executing opqueue");
                        while(running) {
				dec.executeQueuedOp();
				try {
					sleep(100L);
				} catch(InterruptedException e) { e.printStackTrace(); }
			}
                        try {
                            sleep(1000L);
                        } catch(InterruptedException e) { e.printStackTrace(); }
                        // Migration
                        if(destinationHost != null){
                            LimeTupleSpace migrationSpace = new LimeTupleSpace(CommonPluginTerms.MIGRATION_TS_VERSION_1_0);
                            migrationSpace.setShared(true);
                            // Suche Administrator
                            Plugin lookup = ((MeierPlayerDecisionComponent)decision).getPlugin(CommonPluginTerms.PLAYER_LOOKUP_PLUGIN,1.0);
                            LUAdministratorMessage migrationAdmin = ((LookupPlayerPlugin)lookup).getAdmin(new LUAdministratorNachricht(CommonPluginTerms.MIGRATION_ADMINISTRATOR,-42, CommonPluginTerms.MIGRATION_TS_VERSION_1_0, null));
                            AgentLocation admin = migrationAdmin.getPlace();
                            LUMigrationboardNachricht lumn = new LUMigrationboardNachricht(-42, null, null,1.0);
                            LUMigrationboardMessage migrationHost = ((LookupPlayerPlugin)lookup).getMigrationboard(lumn);
                            HostLocation host = migrationHost.getPlace();
                            // Stelle Tuple in Space
                            lts.in((new MigrationToken()).free());
                            decision.deactivate();
                            
                            while(!decision.isMigratable()){
                                try{
                                    sleep(500L);
                                }catch (InterruptedException e){ 
                                    e.printStackTrace();
                                }
                                System.out.print(".");
                            }
                            lookup.deactivate();
                            while(!lookup.isMigratable()){
                                System.out.println("CasinoAgent: lookup not ready!");
                                try{
                                    sleep(500L);
                                }catch (InterruptedException e){ 
                                    e.printStackTrace();
                                }
                                System.out.print(".");
                            }
                            showMessage("Starting Migration!");
                            ((DecisionPlugIn)decision).setAgent(null);
                            DecisionContainer migrationMessage = new DecisionContainer(destinationHost,(DecisionPlugIn)decision);
                            showMessage("CA: Sending migration Message: "+migrationMessage.getResultTuple());
                            showMessage("CA: Writing to Location: "+admin);
                            migrationSpace.out(admin,migrationMessage.getResultTuple());
                            lts.out((new MigrationToken()).lock());
                            // Beende dich selbst
                            decision = null;
                            try{
                                sleep(20000L);
                            }catch (InterruptedException e){ 
                                e.printStackTrace();
                            }
                            //lts.setShared(false);
                            
                            /*showMessage("Unsharing Migration-Tuplespace!");
                            //LimeServer.getServer().disengage();
                            //LimeTupleSpace lts2 = new LimeTupleSpace("BugChecker");
                            //lts2.setShared(true);
                            migrationSpace.setShared(false);
                            showMessage("Migration-Tuplespace shared: "+migrationSpace.isShared());*/
                        }
                        
                        while(true){
                            try{
                                sleep(10000);
                            }catch(Exception e){}
                        }
                        
                        //showMessage("Disengaging Server!");
                        //LimeServer.getServer().disengage();
                       // showMessage("LimeServer engaged: "+LimeServer.getServer().isEngaged());
		} catch (LimeException e) { e.printStackTrace(); }
			
	}
						
						  

    public long getID() {
        return ID;
    }
    
    public HostLocation getHost(){        
        return hostL;
    }
    
    public AgentLocation getAdmin(){
        return agentL;
    }
    
    public void migrate(HostLocation destination){
        System.out.println("CasinoAgent: Migration wanted");
        running = false;
        destinationHost = destination;
    }
    
    protected void showMessage(String out){
        System.out.println("CasinoAgent "+this.ID+": "+out);
    }
    
}
