/*
 * CasinoAgent.java
 *
 * Created on 11. Juni 2002, 11:02
 */

package casino.agents;
import lime.*;
import lights.adapters.*;
import lights.interfaces.*;
import java.io.*;
import casino.plugins.decision.*; 
import casino.plugins.*;
import casino.misc.*;
import casino.plugins.lookup.*;
import casino.plugins.lookup.basic.*;
import casino.plugins.lookup.version1_0.*;
import casino.migration.*;


/**
 *
 * @author  marcel 
 * @version 1.0
 */

public class MigratedCasinoAgent extends CasinoAgent{
    
    protected long ID = -1;
    protected boolean readyForAction = false;
    protected LimeTupleSpace lts = null;
    protected boolean running = true;
    protected int decisionVersion = 0; // = PluginID
    protected casino.plugins.Plugin decision = null;
    protected AgentLocation agentL = null;
    protected HostLocation hostL = null;
    
    /** Creates new CasinoAgent */
    public MigratedCasinoAgent() {
        super();
    }
    
    public void initialize(casino.plugins.Plugin initialDecision){
        decision = initialDecision;
    }
    
    public LimeServer getLimeServer() {
            return LimeServer.getServer();
    }

    public void run() {

            // Initialize PluginBoard access
        while(decision == null){
            try{
                sleep(100);
            }catch(Exception e){}
        }
        try {
            showMessage("MA: Launching migrated agent ...!");
            showMessage("=================================");
            showMessage("");
            lts = new LimeTupleSpace(CommonPluginTerms.PLUGINBOARD_TS_VERSION_1_0);
            lts.setShared(true);
            showMessage("MA: Tuplespcae shared: "+lts.isShared());
            //LimeServer.getServer().engage();
            
            hostL = new HostLocation(LimeServer.getServer().getServerID());
            agentL = new AgentLocation(getMgr().getID());
            System.out.println("Erfrage Token");
            lts.in((new MigrationToken()).lock());
            System.out.println("Token erhalten");
            ((DecisionPlugIn)decision).setAgent(this);
            ((DecisionPlugIn)decision).setOpQueue(new OpQueue(lts));
            ID = ((DecisionPlugIn)decision).getID();
            decision.activate();               
            while(!decision.isActive()){
                try {
                    sleep(500L);
                } catch(InterruptedException e) { e.printStackTrace(); }
            }
            Plugin lookup = ((MeierPlayerDecisionComponent)decision).getPlugin(CommonPluginTerms.PLAYER_LOOKUP_PLUGIN,1.0);
            LUAdministratorMessage message = ((PlayerLookupPlugin)lookup).getAdmin(new LUAdministratorNachricht(null, -42, CommonPluginTerms.PLUGINBOARD_TS_VERSION_1_0,null));
            LUPluginboardMessage message2 = ((PlayerLookupPlugin)lookup).getPluginboard(new LUPluginboardNachricht(-42, null, null, 1.0));                
            AgentLocation loca = message.getPlace();
            HostLocation hola = message2.getPlace();
            lts.out(loca,(new MigrationToken()).free());
            showMessage("MA: DecisionComponent initialized: Now executing opqueue");
            readyForAction = true;
            while(running) {
                    decision.executeQueuedOp();
                    try {
                            sleep(500L);
                    } catch(InterruptedException e) { e.printStackTrace(); }
            }
            try {
                sleep(1000L);
            } catch(InterruptedException e) { e.printStackTrace(); }
            // Migration
            if(destinationHost != null){
                
                ITuple migration = null;
                while(migration == null){
                    migration = lts.inp(hola,AgentLocation.UNSPECIFIED,(new MigrationToken()).free());
                }
                LimeTupleSpace migrationSpace = new LimeTupleSpace(CommonPluginTerms.MIGRATION_TS_VERSION_1_0);
                migrationSpace.setShared(true);
                // Suche Administrator
                lookup = ((MeierPlayerDecisionComponent)decision).getPlugin(CommonPluginTerms.PLAYER_LOOKUP_PLUGIN,1.0);
                LUAdministratorMessage migrationAdmin = ((LookupPlayerPlugin)lookup).getAdmin(new LUAdministratorNachricht(CommonPluginTerms.MIGRATION_ADMINISTRATOR,-42, CommonPluginTerms.MIGRATION_TS_VERSION_1_0, null));
                AgentLocation admin = migrationAdmin.getPlace();
                LUMigrationboardNachricht lumn = new LUMigrationboardNachricht(-42, null, null,1.0);
                LUMigrationboardMessage migrationHost = ((LookupPlayerPlugin)lookup).getMigrationboard(lumn);
                HostLocation host = migrationHost.getPlace();
                // Stelle Tuple in Space
                lookup.deactivate();
                decision.deactivate();
                
                            
                while(!decision.isMigratable()){
                    System.out.println("MigratedCasinoAgent: Migration not possible!");
                    try{
                        sleep(500L);
                    }catch (InterruptedException e){ 
                        e.printStackTrace();
                    }
                    System.out.print(".");
                }
                lookup.deactivate();
                while(!lookup.isMigratable()){
                    System.out.println("MigratedCasinoAgent: lookup not ready!");
                    try{
                        sleep(500L);
                    }catch (InterruptedException e){ 
                        e.printStackTrace();
                    }
                    System.out.print(".");
                }
                showMessage("Starting Migration!");
                ((DecisionPlugIn)decision).setAgent(null);
                DecisionContainer migrationMessage = new DecisionContainer(destinationHost,(DecisionPlugIn)decision);
                showMessage("CA: Sending migration Message: "+migrationMessage.getResultTuple());
                showMessage("CA: Writing to Location: "+admin);
                migrationSpace.out(admin,migrationMessage.getResultTuple());
                // Beende dich selbst
                decision = null;
                try{
                    sleep(500L);
                }catch (InterruptedException e){}
                System.out.println("Gebe Token frei in "+lts);
                lts.out(loca,(new MigrationToken()).lock());
                System.out.println("Token freigegeben!");
                try{
                    sleep(100000L);
                }catch (InterruptedException e){ 
                    e.printStackTrace();
                }
                //lts.setShared(false);

                /*showMessage("Unsharing Migration-Tuplespace!");
                //LimeServer.getServer().disengage();
                //LimeTupleSpace lts2 = new LimeTupleSpace("BugChecker");
                //lts2.setShared(true);
                migrationSpace.setShared(false);
                showMessage("Migration-Tuplespace shared: "+migrationSpace.isShared());*/
            }
            
            while(true){
                try{
                    sleep(10000);
                }catch(Exception e){}
            }

            //showMessage("Disengaging Server!");
            //LimeServer.getServer().disengage();
           // showMessage("LimeServer engaged: "+LimeServer.getServer().isEngaged());
        } catch (LimeException e) { e.printStackTrace(); 
    }

    }						  

    public long getID() {
        return ID;
    }
    
    public HostLocation getHost(){        
        return hostL;
    }
    
    public AgentLocation getAdmin(){
        return agentL;
    }
    
    protected void showMessage(String out){
        System.out.println("MCasinoAgent"+this.ID+": "+out);
    }
    
    public void migrate(HostLocation destination){
        System.out.println("CasinoAgent: Migration wanted");
        running = false;
        destinationHost = destination;
    }
    
    public boolean isReady(){
        return readyForAction;
    }
    
}
