/*
 * LookupAdministrator.java
 *
 * Created on 22. Juni 2002, 00:19
 */

package casino.agents.environment.lookup;

import lime.*;

import java.net.InetAddress;

import casino.plugins.lookup.*;
import casino.plugins.lookup.version1_0.*;
import casino.plugins.*;

/**
 *
 * @author  jens
 * @version 
 */
public class LookupAdministrator extends StationaryAgent implements LookupAdmin {
    
    protected static final double version = 1.0;
    protected boolean active = true;
    protected long nextID = 1;
    
    /** Creates new LookupAdministrator */
    public LookupAdministrator() {
        
    }

    public void run() {
        System.out.println("Declaring leader");
        LimeServer.getServer().declareLeader();
        System.out.println("Leader declared");
        LimeTupleSpace lts = null;
        try{
            lts = new LimeTupleSpace(CommonPluginTerms.LOOKUP_TS_VERSION_1_0);
            if(lts != null){                
                lts.setShared(true);
                System.out.println("TS shared: "+lts.isShared());
                LimeServer.getServer().engage();
                System.out.println("Server engaged: "+LimeServer.getServer().isEngaged());
                VersionNachricht vn = new VersionNachricht(version);
                // Version des Kommunikationsprotokolls setzen
                lts.out(new AgentLocation(getMgr().getID()),vn.getResultTuple());
                try{
                    // Selbst als Admin eintragen
                    LUAdministratorNachricht an = new LUAdministratorNachricht("LookupLeader",0,CommonPluginTerms.LOOKUP_TS_VERSION_1_0,new AgentLocation(getMgr().getID()));
                    lts.out(new AgentLocation(getMgr().getID()),an.getResultTuple());
                    // Als Lookup eintragen
                    LULookupNachricht ln = new LULookupNachricht(new HostLocation(LimeServer.getServer().getServerID()),CommonPluginTerms.LOOKUP_TS_VERSION_1_0,0);
                    lts.out(new AgentLocation(getMgr().getID()),ln.getResultTuple());
                }catch(Exception e){e.printStackTrace();}  
                // Neue ID abholbereit machen
                LUIDNachricht in = new LUIDNachricht(nextID++);
                lts.out(new AgentLocation(getMgr().getID()),in.getResultTuple());
                LUIDNachricht dummyID = new LUIDNachricht(-42);
                System.out.println("Ready for action");
                while(active){
                    while(lts.rdp(new AgentLocation(this.getMgr().getID()),new AgentLocation(this.getMgr().getID()), dummyID.getRequestTuple()) == null){
                        // Falls keine ID abholbar, neue erstellen
                        in = new LUIDNachricht(nextID++);
                        lts.out(new AgentLocation(this.getMgr().getID()),in.getResultTuple());
                        sleep(10L);
                    }
                    sleep(100L);
                }
            }
        }catch(Exception e){e.printStackTrace();System.out.println("Lookup-Admin-Fehler");}
    }
    
    public void deactivate() {
        active = false;
    }
    
}
