/*
 * WBAdmin.java
 *
 * Created on 7. Juni 2002, 22:18
 */

package casino.agents.environment.whiteboard;

import casino.plugins.*;
import casino.plugins.lookup.version1_0.*;
import casino.plugins.lookup.*;

import lime.*;
import lights.adapters.*;

/**
 *
 * @author  Jens Bruhn
 * @version 
 */
public class WhiteboardAdministrator extends StationaryAgent implements WhiteboardAdmin {
    protected LimeTupleSpace whiteboard = null;
    protected LimeTupleSpace lookup = null;
    protected long ID = -42;
    protected boolean active = true;

    /** Creates new WBAdmin */
    public WhiteboardAdministrator(){
    }
    
    public void run() {
        try {
            lookup = new LimeTupleSpace(CommonPluginTerms.LOOKUP_TS_VERSION_1_0);
            lookup.setShared(true);
            LimeServer.getServer().engage();
            VersionNachricht lvn= new VersionNachricht(lookup.rd((new VersionNachricht(-5)).getRequestTuple()));
            if(lvn.getVersion() == 1.0){
                whiteboard = new LimeTupleSpace(CommonPluginTerms.WHITEBOARD_TS_VERSION_1_0);
                System.out.println("Tuplespace erstellt!");
                whiteboard.setShared(true);
                System.out.println("Tuplespace shared: "+whiteboard.isShared());
                LULookupNachricht ln = new LULookupNachricht(lookup.rd(new LULookupNachricht(null,CommonPluginTerms.LOOKUP_TS_VERSION_1_0,-5).getRequestTuple()));
                HostLocation lookupHost = ln.getPlace();
                System.out.println("Lookup-Host: "+ln.getPlace());
                LUAdministratorNachricht an = new LUAdministratorNachricht(lookup.rd(new LUAdministratorNachricht(null,-5,CommonPluginTerms.LOOKUP_TS_VERSION_1_0,null).getRequestTuple()));
                AgentLocation lookupPostbox = an.getPlace();
                System.out.println("Lookup-Administrator: "+an.getPlace());
                LUIDNachricht idn = new LUIDNachricht(lookup.in(new LUIDNachricht(-42).getRequestTuple()));
                ID = idn.getID();
                System.out.println("Own ID: "+ID);
                lookup.out(lookupPostbox,new LUAdministratorNachricht("WhiteboardLeader",ID,CommonPluginTerms.WHITEBOARD_TS_VERSION_1_0,new AgentLocation(getMgr().getID())).getResultTuple());
                System.out.println("Registered Administrator at Lookup.");
                lookup.out(lookupPostbox,new LUWhiteboardNachricht(ID,new HostLocation(LimeServer.getServer().getServerID()),CommonPluginTerms.WHITEBOARD_TS_VERSION_1_0,1.0).getResultTuple());
                System.out.println("Registered Whiteboard at Lookup.");
                whiteboard.out(new AgentLocation(getMgr().getID()),new VersionNachricht(1.0).getResultTuple());
                System.out.println("Version of Whiteboard set.");
                while(active){
                    sleep(2000);
                } 
                lookup.inp(lookupHost,AgentLocation.UNSPECIFIED,new LUAdministratorNachricht("WhiteboardLeader",ID,CommonPluginTerms.WHITEBOARD_TS_VERSION_1_0,new AgentLocation(getMgr().getID())).getResultTuple());
                lookup.inp(lookupHost,AgentLocation.UNSPECIFIED,new LUWhiteboardNachricht(ID,new HostLocation(LimeServer.getServer().getServerID()),CommonPluginTerms.WHITEBOARD_TS_VERSION_1_0,1.0).getResultTuple());
                whiteboard.in(new VersionNachricht(1.0).getResultTuple());
            }else{
                System.out.println("Unable to administrate: Wrong Lookup-Version!");
            }
        }catch (Exception e) { e.printStackTrace(); }
    }
    
    public void deactivate(){
        active = false;
    }
}