/*
 * MeierPlayer.java
 *
 * Created on 05. Juli 2002, 08:50
 */

package casino.agents.human.meier;

import lime.*;
import lights.interfaces.*;
import lights.adapters.*;

import casino.plugins.*;
import casino.plugins.decision.*;
import casino.misc.*;

/**
 *
 * @author  sven
 * @version 
 */
public class MeierHumanPlayerAgent extends casino.agents.CasinoAgent {

    /** Creates new MeierPlayer */
    public MeierHumanPlayerAgent() {
    }

    public void run() {
        // Initialize PluginBoard access
		try {
			lts = new LimeTupleSpace(CommonPluginTerms.PLUGINBOARD_TS_VERSION_1_0);
			lts.setShared(true);
                        System.out.println("TS shared: "+lts.isShared());
			LimeServer.getServer().engage();

			System.out.println("CA: Connected to PluginBoard "+LimeServer.getServer().isEngaged());
                        try{
                            ITuple tuple = new Tuple();
                            tuple.addActual(new String("ADMINLOC"));
                            tuple.addFormal(AgentLocation.class);
                            ITuple result = lts.rd(tuple);
                            
                            agentL = (AgentLocation) result.get(1).getValue();
                            System.out.println("Admin-Location: "+agentL);
                        }catch(Exception e){e.printStackTrace();}
                        try{
                            ITuple tuple = new Tuple();
                            tuple.addActual(new String("HOSTLOC"));
                            tuple.addFormal(HostLocation.class);
                            ITuple result = lts.rd(tuple);
                            hostL = (HostLocation) result.get(1).getValue();
                            System.out.println("Host-Location: "+hostL);
                        }catch(Exception e){e.printStackTrace();}
			// Now get the DecisionPlugin from the PluginBoard
			/*ITuple decisionTemplate = new Tuple();
			if(leader) {
				decisionTemplate.addActual(casino.plugins.CommonPluginTerms.LEADER_DECISION_PLUGIN);
			} else {
				decisionTemplate.addActual(casino.plugins.CommonPluginTerms.PLAYER_DECISION_PLUGIN);
			}		 
			decisionTemplate.addActual(new Double(0));
			decisionTemplate.addFormal(PluginContainer.class);

			ITuple decisionRead = lts.rd(decisionTemplate);
			System.out.println("CA: Received DecisionPlugIn");
			PluginContainer container = (PluginContainer) decisionRead.get(2).getValue();		
			decision = container.getPlugin();*/
                        MeierHumanPlayerDecisionComponent decision = new MeierHumanPlayerDecisionComponent();
                        DecisionPlugIn dec = (DecisionPlugIn)decision;
                        dec.setAgent(this);
                        dec.setOpQueue(new OpQueue(lts));
			dec.activate();
		
			System.out.println("CA: DecisionComponent initialized: Now executing opqueue");
                        while(dec.isActive()) {
				dec.executeQueuedOp();
				try {
					sleep(100L);
				} catch(InterruptedException e) { e.printStackTrace(); }
			}
                        while(!dec.isMigratable()){
                            try {
                                sleep(1000L);
                            } catch(InterruptedException e) { e.printStackTrace(); }
                        }
                        lts.setShared(false);
		} catch (LimeException e) { e.printStackTrace(); }
    }
    
    public void migrate(HostLocation destination) {
    }
    
}
