/*
 * MeierHumanPlayerDecisionComponent.java
 *
 * Created on 05. Juli 2002, 09:00
 */

package casino.agents.human.meier;

import java.util.Hashtable;
import java.util.Enumeration;

import lime.*;
import lights.interfaces.*;
import lights.adapters.*;

import casino.agents.*;
import casino.plugins.*;
import casino.plugins.game.meier.*;
import casino.plugins.whiteboard.*;
import casino.plugins.lookup.*;
import casino.misc.*;

/**
 *
 * @author  sven
 * @version 1.0
 */
public class MeierHumanPlayerDecisionComponent extends casino.plugins.decision.MeierPlayerDecisionComponent {

    /** Creates new MeierHumanPlayerDecisionComponent */
    public MeierHumanPlayerDecisionComponent() {
    }
    
    public Plugin getPlugin(String PluginName,double pluginVersion){
        Plugin rueckgabe = (Plugin)plugins.get(PluginName);
        if((rueckgabe != null) && (((long)rueckgabe.getVersion() != (long)pluginVersion)||(rueckgabe.getVersion() < pluginVersion))){
            plugins.remove(PluginName);
            rueckgabe = null;
        }
        if(rueckgabe == null){
            ITuple lookupTuple = new Tuple();
            lookupTuple.addActual(PluginName);
            lookupTuple.addActual(new Double(pluginVersion));
            lookupTuple.addFormal(PluginContainer.class);
            try{
                rueckgabe = ((PluginContainer)operationQueue.enqueueOp("rdp",new Object[]{agent.getHost(),agent.getAdmin(),lookupTuple})).getPlugin(); 
            }catch(Exception e){e.printStackTrace();}
            plugins.put(PluginName,rueckgabe);
        }
        return rueckgabe;
    }
    
    protected void initialize(){
        if(plugins == null){
            plugins = new Hashtable();
            Plugin lookup = null;
            ITuple lookupTuple = new Tuple();
            lookupTuple.addActual(CommonPluginTerms.PLAYER_LOOKUP_PLUGIN);
            lookupTuple.addActual(new Double(0));
            lookupTuple.addFormal(PluginContainer.class);
            try{
                System.out.println("Host: "+agent.getHost());
                System.out.println("Agent: "+agent.getAdmin());
                PluginContainer clookup = (PluginContainer) ((ITuple)operationQueue.enqueueOp("rdp",new Object[]{agent.getHost(),agent.getAdmin(),lookupTuple})).get(2).getValue(); 
                lookup = clookup.getPlugin();
            }catch(Exception e){e.printStackTrace();}
            if(lookup != null){
                plugins.put(LOOKUP,lookup);
                ((LookupPlayerPlugin)lookup).setAgent(this);
                lookup.activate();
                while(!lookup.isActive()){

                }
            }
            System.out.println("Lookup aktiviert!");
            Plugin whiteboard = null;
            ITuple whiteboardTuple = new Tuple();
            whiteboardTuple.addActual(CommonPluginTerms.PLAYER_WHITEBOARD_PLUGIN);
            whiteboardTuple.addActual(new Double(0));
            whiteboardTuple.addFormal(PluginContainer.class);
            try{
                PluginContainer wlookup = (PluginContainer) ((ITuple)operationQueue.enqueueOp("rdp",new Object[]{agent.getHost(),agent.getAdmin(),whiteboardTuple})).get(2).getValue(); 
                whiteboard = wlookup.getPlugin();
            }catch(Exception e){e.printStackTrace();}
            if(whiteboard != null){
                plugins.put(WHITEBOARD, whiteboard);
                ((WhiteboardPlayerPlugin)whiteboard).setLeader(this);
                System.out.println("Aktiviere Whiteboard!");
                whiteboard.activate();
                while(!whiteboard.isActive()){

                }
            }
            /*Plugin meier = null;
            ITuple meierTuple = new Tuple();
            meierTuple.addActual(CommonPluginTerms.PLAYER_MEIER_PLUGIN);
            meierTuple.addActual(new Double(0));
            meierTuple.addFormal(PluginContainer.class);
            try{
                PluginContainer mlookup = (PluginContainer) ((ITuple)operationQueue.enqueueOp("rdp",new Object[]{agent.getHost(),agent.getAdmin(),meierTuple})).get(2).getValue(); 
                meier  = mlookup.getPlugin();
            }catch(Exception e){e.printStackTrace();}
            if(meier != null){
                plugins.put(MEIER,meier);
                ((MeierPlayer)meier).setDecisionPlugin(this);
                /*meier.activate();
                while(!meier.isActive()){

                }
            }*/
            MeierPlayerPlugin meier = new MeierPlayerPlugin();
            meier.setDecisionPlugin(this);
            plugins.put(MEIER,meier);
        }else{
            Enumeration enum = plugins.elements();
            while(enum.hasMoreElements()){
                Plugin plugin = ((Plugin)enum.nextElement());
                if(plugin.getTyp() != casino.plugins.CommonPluginTerms.PLAYER_MEIER_PLUGIN){
                    plugin.activate();
                }
            }
        }
        System.out.println("Initialisierung Player-Decision-Komponente abgeschlossen!");
    }
    
    public void run(){
        active = true;
        readyForMigration = false;
        migrationHost = null;
        //while ( (migrationHost == null) && (gamesPlayed < gamesToPlay) ){
            lastGameEndState = GAME_DID_NOT_END;
            initialize();

            // Teste Status
            seekGame();
            while (lastGameEndState == GAME_DID_NOT_END){
                try{
                    sleep(10000L);
                }catch (InterruptedException e){
                    e.printStackTrace();
                }
            }

            // Deaktiviere Plugins
            Enumeration enum = plugins.elements();
            while(enum.hasMoreElements()){
                ((Plugin)enum.nextElement()).deactivate();
            }
            
            readyToPlay = false;
            if (lastGameEndState == this.GAME_LOGON_DENIED){
                try {
                    sleep(4000L);
                }catch (InterruptedException e){
                    e.printStackTrace();
                }
            }

            while (!this.migratable()){
                try {
                    sleep(10000L);
                }catch (InterruptedException e){
                    e.printStackTrace();
                }
            }
            active = false;
            
        //}
    }
    
    public boolean isActive(){
        return active;
    }

}
