/*
 * MeierPlayerPlugin.java
 *
 * Created on 11. Juli 2002, 09:16
 */

package casino.agents.human.meier;

import lime.*;

import casino.plugins.*;
import casino.plugins.game.meier.*;
import casino.plugins.decision.DecisionPlugIn;
import casino.plugins.whiteboard.*;
import casino.plugins.whiteboard.Version1_0.*;
import casino.plugins.whiteboard.basic.*;
import casino.plugins.lookup.*;
import casino.plugins.lookup.version1_0.*;
import casino.plugins.lookup.basic.*;
import casino.agents.human.meier.gui.*;


/**
 *
 * @author  administrator
 * @version 
 */
public class MeierPlayerPlugin extends casino.plugins.game.meier.MeierPlayer {

    protected boolean takeOver = false;
    protected boolean textMode = true;
    protected MeierHumanPlayerGUI gui = null;
    protected boolean guiVisible = false;
    
    /** Creates new MeierPlayerPlugin */
    public MeierPlayerPlugin() {
        this.textMode = false;
        gui = new MeierHumanPlayerGUI();
        gui.setMeierPlayerPlugin(this);
        this.strategy = (MeierPlayerStrategyPlugin)gui;
    }
    
    public void takeOver(){
        this.strategy = new MeierStrategyPlugin();
    }
    
    public int getPoints(){
        return this.myPoints;
    }
    
    public void activate(){
        new Thread (new Runnable() {
            public void run(){
                guiVisible = true;
                gui.show();
            }
        }).start();
        showMessage("DecisionMaker: "+decisionMaker);
        WhiteboardPlayerPlugin whiteboard = (WhiteboardPlayerPlugin)decisionMaker.getPlugin(CommonPluginTerms.PLAYER_WHITEBOARD_PLUGIN, 1.0);
        WBGameMessage foundGame = (WBGameMessage)whiteboard.seekGame(CommonPluginTerms.MEIER_GAME, getVersion());
        showMessage("Found Game: "+foundGame);
        if (foundGame == null){
            //decisionMaker benachrichtigen
            if (textMode) showMessage("No Game found.");
        }else{
            LookupPlayerPlugin lookup = (LookupPlayerPlugin)decisionMaker.getPlugin(CommonPluginTerms.PLAYER_LOOKUP_PLUGIN, 1.0);
            LUGameMessage gameLookupEntry = new LUGameNachricht(foundGame.getGameName(), foundGame.getTuplespace(), null, foundGame.getLeaderID(), getVersion());
            //zum migrieren auffordern
            LUGameMessage foundLookupEntry = lookup.getGame(gameLookupEntry);
            HostLocation gameLocation = foundLookupEntry.getPlace();
            decisionMaker.setMigrationHost(gameLocation);
            leaderID = foundGame.getLeaderID();
            TStoUse = foundGame.getTuplespace();
        }
        activate(TStoUse);
    }
    
    public void activate(String TSName) {
        if (!guiVisible){
            new Thread (new Runnable() {
                public void run(){
                    guiVisible = true;
                    gui.show();
                }
            }).start();
        }
        super.activate(TSName);
    }
    
    public void setDecisionPlugin(DecisionPlugIn decision){
        super.setDecisionPlugin(decision);
        gui.setTitle("Meierplayer "+decisionMaker.getID());
    }
    
    

}
