/*
 * DecisionComtainer.java
 *
 * Created on 8. Juli 2002, 21:17
 */

package casino.migration;

import java.io.*;

import lime.*;
import lights.adapters.*;
import lights.interfaces.*;

import casino.plugins.decision.*;

/**
 *
 * @author  jens
 * @version 
 */
public class DecisionContainer implements Serializable {

    protected static final String tupleName = "MigrationRequest";
    protected HostLocation hostLocation = null;
    protected DecisionPlugIn plugin = null;
    protected Paket paket = new Paket(null);
    
    /** Creates new DecisionComtainer */
    public DecisionContainer(HostLocation initialHost,DecisionPlugIn initialPlugin) {
        hostLocation = initialHost;
        plugin = initialPlugin;
        if (plugin != null) paket = new Paket(plugin);
    }
    
    public DecisionContainer(ITuple tuple){
        boolean match = true;
        IField[] fields = tuple.getFields();
        if(fields.length != 3){
            System.out.println("Tuple-Length does not match!");
            match = false;
        }
        else{
            if(!fields[0].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            else{
                if(!((String)(fields[0].getValue())).equals(tupleName)){
                    System.out.println("Wrong Tuple-Type!");
                    match = false;
                }
            }
        }
        if(match){
            hostLocation = (HostLocation)fields[1].getValue();
            plugin = (DecisionPlugIn)((Paket)fields[2].getValue()).getPlugin();
        }
    }
    
    public DecisionPlugIn getPlugin(){
        return plugin;        
    }
    
    public void setPlugin(DecisionPlugIn newPlugin){
        plugin = newPlugin;
        paket.setPlugin(plugin);
    }
    
    public HostLocation getHost(){
        return hostLocation;
    }

    public void setHost(HostLocation newHost){
        hostLocation = newHost;
    }
    
    public ITuple getRequestTuple(){
        Tuple tuple = new Tuple();
        Field field0 = new Field();
        Field field1 = new Field();
        Field field2 = new Field();
        field0.setToActual(tupleName);
        if(hostLocation != null){
            field1.setToActual(hostLocation);
        }else{
            field1.setToFormal(HostLocation.UNSPECIFIED.getClass());
        }
        if(plugin != null){
            field2.setToActual(paket);
        }else{
            field2.setToFormal(Paket.class);
        }
        tuple.add(field0);
        tuple.add(field1);
        tuple.add(field2);
        return tuple;
    }
    
    public ITuple getResultTuple(){
        Tuple tuple = new Tuple();
        Field field0 = new Field();
        Field field1 = new Field();
        Field field2 = new Field();
        field0.setToActual(tupleName);
        if(hostLocation != null){
            field1.setToActual(hostLocation);
        }else{
            field1.setToNullActual(HostLocation.UNSPECIFIED.getClass());
        }
        if(plugin != null){
            field2.setToActual(paket);
        }else{
            field2.setToNullActual(Paket.class);
        }
        tuple.add(field0);
        tuple.add(field1);
        tuple.add(field2);
        return tuple;
    }
    
}
