/*
 * MigrationAdministrator.java
 *
 * Created on 8. Juli 2002, 20:49
 */

package casino.migration;

import lime.*;
import lights.adapters.*;

import casino.plugins.*;
import casino.plugins.lookup.version1_0.*;
import casino.plugins.lookup.*;

/**
 *
 * @author  jens
 * @version 
 */
public class MigrationAdministrator extends StationaryAgent {
    
    protected LimeTupleSpace migrationBoard = null;
    protected LimeTupleSpace lookup = null;
    protected AgentLocation location = null;
    protected HostLocation host = null;
    protected long ID = -42;
    protected boolean online = true;

    /** Creates new MigrationAdministrator */
    public MigrationAdministrator() {
    }
    
    public void run() {
        try {
            lookup = new LimeTupleSpace(CommonPluginTerms.LOOKUP_TS_VERSION_1_0);
            lookup.setShared(true);
            LimeServer.getServer().engage();            
            migrationBoard = new LimeTupleSpace(CommonPluginTerms.MIGRATION_TS_VERSION_1_0);
            migrationBoard.setShared(true);
            migrationBoard.out(new AgentLocation(getMgr().getID()),new VersionNachricht(1.0).getResultTuple());
            VersionNachricht lvn= new VersionNachricht(lookup.rd((new VersionNachricht(-5)).getRequestTuple()));
            if(lvn.getVersion() == 1.0){
                LULookupNachricht ln = new LULookupNachricht(lookup.rd(new LULookupNachricht(null,CommonPluginTerms.LOOKUP_TS_VERSION_1_0,-5).getRequestTuple()));
                HostLocation lookupHost = ln.getPlace();
                LUAdministratorNachricht an = new LUAdministratorNachricht(lookup.rd(new LUAdministratorNachricht(null,-5,CommonPluginTerms.LOOKUP_TS_VERSION_1_0,null).getRequestTuple()));
                AgentLocation lookupPostbox = an.getPlace();
                LUIDNachricht idn = new LUIDNachricht(lookup.in(new LUIDNachricht(-42).getRequestTuple()));
                ID = idn.getID();
                showMessage("MigrationAdmin: writing out to Lookup my place: "+new LUAdministratorNachricht(CommonPluginTerms.MIGRATION_ADMINISTRATOR,ID,CommonPluginTerms.MIGRATION_TS_VERSION_1_0,new AgentLocation(getMgr().getID())).getResultTuple());
                lookup.out(lookupPostbox,new LUAdministratorNachricht(CommonPluginTerms.MIGRATION_ADMINISTRATOR,ID,CommonPluginTerms.MIGRATION_TS_VERSION_1_0,new AgentLocation(getMgr().getID())).getResultTuple());
                lookup.out(lookupPostbox,new LUMigrationboardNachricht(ID,new HostLocation(LimeServer.getServer().getServerID()),CommonPluginTerms.MIGRATION_TS_VERSION_1_0,1.0).getResultTuple());                
                showMessage("MigrationAdministrator: Migration-TS initialized!");
                while(online){                    
                    sleep(20000);
                }
                lookup.inp(lookupHost,AgentLocation.UNSPECIFIED,new LUAdministratorNachricht(CommonPluginTerms.MIGRATION_ADMINISTRATOR,ID,CommonPluginTerms.MIGRATION_TS_VERSION_1_0,new AgentLocation(getMgr().getID())).getResultTuple());
                lookup.inp(lookupHost,AgentLocation.UNSPECIFIED,new LUMigrationboardNachricht(ID,new HostLocation(LimeServer.getServer().getServerID()),CommonPluginTerms.MIGRATION_TS_VERSION_1_0,1.0).getResultTuple());
                migrationBoard.in(new VersionNachricht(lookup.rd((new VersionNachricht(-5)).getRequestTuple())).getRequestTuple());
            }
        }catch (Exception e) { e.printStackTrace(); }
    }
    
    protected void showMessage(String out){
        System.out.println("MigrationAdministrator "+this.ID+": "+out);
    }
    

}
