/*
 * MigrationTeleporter.java
 *
 * Created on 8. Juli 2002, 20:24
 */

package casino.migration;

import lime.*;
import lights.adapters.*;
import lights.interfaces.*;

import casino.plugins.*;
import casino.plugins.lookup.version1_0.*;
import casino.plugins.lookup.*;
import casino.plugins.decision.*;
import casino.agents.*;

/**
 *  Dieser Agent dient als Endpunkt fr die Migration.
 *
 * @author  jens
 * @version 
 */
public class MigrationTeleporter extends StationaryAgent{
    
    protected LimeTupleSpace migrationBoard = null;
    protected LimeTupleSpace lookup = null;
    protected AgentLocation location = null;
    protected HostLocation host = null;
    protected long ID = -42;
    protected boolean online = true;

    /** Creates new MigrationTeleporter */
    public MigrationTeleporter() {
        
    }
    
    public void run() {
        try {
            //LimeServer.getServer().declareLeader();
            lookup = new LimeTupleSpace(CommonPluginTerms.LOOKUP_TS_VERSION_1_0);
            lookup.setShared(true);
            this.showMessage("Engaging Server");
            LimeServer.getServer().engage();
            this.showMessage("engaged");
            migrationBoard = new LimeTupleSpace(CommonPluginTerms.MIGRATION_TS_VERSION_1_0);
            migrationBoard.setShared(true);
            VersionNachricht lvn= new VersionNachricht(lookup.rd((new VersionNachricht(-5)).getRequestTuple()));
            if(lvn.getVersion() == 1.0){
                LULookupNachricht ln = new LULookupNachricht(lookup.rd(new LULookupNachricht(null,CommonPluginTerms.LOOKUP_TS_VERSION_1_0,-5).getRequestTuple()));
                HostLocation lookupHost = ln.getPlace();
                LUAdministratorNachricht an = new LUAdministratorNachricht(lookup.rd(new LUAdministratorNachricht(null,-5,CommonPluginTerms.LOOKUP_TS_VERSION_1_0,null).getRequestTuple()));
                AgentLocation lookupPostbox = an.getPlace();
                LUIDNachricht idn = new LUIDNachricht(lookup.in(new LUIDNachricht(-42).getRequestTuple()));
                ID = idn.getID();
                lookup.out(lookupPostbox,new LUAdministratorNachricht(CommonPluginTerms.MIGRATION_TELEPORT,ID,CommonPluginTerms.MIGRATION_TS_VERSION_1_0,new AgentLocation(getMgr().getID())).getResultTuple());
                LUMigrationboardNachricht mbn = new LUMigrationboardNachricht(lookup.rd(new LUMigrationboardNachricht(-42,null,null,1.0).getRequestTuple()));
                HostLocation migrationBoardHost = mbn.getPlace();
                LUAdministratorNachricht mban = new LUAdministratorNachricht(lookup.rd(new LUAdministratorNachricht(null,-5,CommonPluginTerms.MIGRATION_TS_VERSION_1_0,null).getRequestTuple()));
                AgentLocation migrationboardPostbox = mban.getPlace();
                DecisionContainer migrationRequest = new DecisionContainer(new HostLocation(LimeServer.getServer().getServerID()),null);
                showMessage("Teleporter: Waiting for MigrationRequests: "+migrationRequest.getRequestTuple());
                showMessage("Reading from Location: "+migrationboardPostbox);
                while(online){
                    //Versuche einen Migrationswunsch zu finden
                    ITuple tuple = migrationBoard.inp(migrationboardPostbox,AgentLocation.UNSPECIFIED,migrationRequest.getRequestTuple());
                    if (tuple != null) showMessage("Tuple found: "+tuple);
                    if(tuple != null){
                        DecisionPlugIn migrationClient = new DecisionContainer(tuple).getPlugin();
                        showMessage("Try to load player");
                        MigratedCasinoAgent newAgent = (MigratedCasinoAgent)LimeServer.getServer().loadAgent("casino.agents.MigratedCasinoAgent",new String[]{});
                        newAgent.initialize(migrationClient);
                        while(!newAgent.isReady()){
                            try{
                                sleep(100L);
                            }catch(Exception e){}
                        }
                    }
                    System.out.print(".");
                    sleep(5000);
                    
                }
                lookup.inp(lookupHost,AgentLocation.UNSPECIFIED,new LUAdministratorNachricht(CommonPluginTerms.MIGRATION_TELEPORT,ID,CommonPluginTerms.MIGRATION_TS_VERSION_1_0,new AgentLocation(getMgr().getID())).getResultTuple());
            }
        }catch (Exception e) { e.printStackTrace(); }
    }
    
    protected void showMessage(String out){
        System.out.println("Migration Teleporter "+this.ID+": "+out);
    }
    

}
