/*
 * Dice.java
 *
 * Created on 18. Juni 2002, 18:02
 */

package casino.misc;

import java.util.Random;

/**
 *
 * @author  sven
 * @version 1.0
 */
public class FairDice implements java.io.Serializable{
    
    public static final int EINS = 1;
    public static final int ZWEI = 2;
    public static final int DREI = 3;
    public static final int VIER = 4;
    public static final int FUENF = 5;
    public static final int SECHS = 6;
    
    Random zufall = null;

    /** Creates new Dice */
    public FairDice() {
    }

    public int roll() {
        if (zufall == null) {zufall = new Random();}
        return tableLookup(zufall.nextFloat(), SECHS);
    }
    
    protected int tableLookup(float p, int numberOfIntervalls){
        
        int result = -1;
        float intervallLength = 1.0f/numberOfIntervalls;
        boolean intervallfound = false;
        for (int i = 0; i < numberOfIntervalls && (!intervallfound); i++){
            if (p < (i+1)*intervallLength) {
                intervallfound = true;
                result = i+1;
            }
        }
        return result;
    }
    
    public void init(long seed) {
        zufall = new Random();
        zufall.setSeed(seed);
    }
    
}
