/*
 * MeierDice.java
 *
 * Created on 18. Juni 2002, 19:03
 */

package casino.misc;

import java.util.Random;
import casino.terms.game.meier.MeierTerms;

/**
 *
 * @author  administrator
 * @version 
 */
public class MeierDice extends FairDice implements java.io.Serializable{
    
    protected final int MEIER_BETRAG = 21;
    
    protected MeierTerms terms = new MeierTerms();
    protected FairDice dice1;
    protected FairDice dice2;
    protected int lastThrow = -1;

    /** Creates new MeierDice */
    public MeierDice() {
        super();
        dice1 = new FairDice();
        dice2 = new FairDice();
        zufall = new Random();
    }
    
    public int roll(){
        
        if ( (dice2 == null) || (dice1 == null) ) { 
            dice2 = new FairDice();
            dice2.init(zufall.nextLong());
            dice1 = new FairDice();
            dice1.init(zufall.nextLong());
        }
        int result = -1;
        int resultDice1 = dice1.roll();
        int resultDice2 = dice2.roll();
        if (resultDice1 > resultDice2){
            result = 10*resultDice1 + resultDice2;
        }else{
            if (resultDice1 < resultDice2){
                result = 10*resultDice2 + resultDice1;
            }else{
                if (resultDice1 == resultDice2){
                    switch (resultDice1){
                        case EINS: {result = terms.EINER_PASCH; break;}
                        case ZWEI: {result = terms.ZWEIER_PASCH; break;}
                        case DREI: {result = terms.DREIER_PASCH; break;}
                        case VIER: {result = terms.VIERER_PASCH; break;}
                        case FUENF: {result = terms.FUENFER_PASCH; break;}
                        case SECHS: {result = terms.SECHSER_PASCH; break;}
                    }
                }
            }
        }
        if (result == MEIER_BETRAG){
            result = terms.MEIER;
        }
        lastThrow = result;
        return result;
    }
    
    public void init(long seed) {
        zufall = new Random();
        zufall.setSeed(seed);
        dice1.init(zufall.nextLong());
        dice2.init(zufall.nextLong());
    }
    
    public int getLastThrow() {
        return lastThrow;
    }
    
}
