/*
 * VersionNachricht.java
 *
 * Created on 17. Juni 2002, 23:12
 */

package casino.plugins;

import lights.interfaces.ITuple;
import lights.interfaces.IField;
import lights.adapters.Tuple;
import lights.adapters.Field;

/**
 *
 * @author  Administrator
 * @version 
 */
public class VersionNachricht implements VersionMessage {

    protected static final String tupleName = "VersionMessage"; 
    double version = -42;
    
    /** Creates new VersionNachricht */
    public VersionNachricht(double initialVersion) {
        version = initialVersion;
    }
    
    public VersionNachricht(ITuple tuple){
        boolean match = true;
        IField[] fields = tuple.getFields();
        if(fields.length != 2){
            System.out.println("Tuple-Length does not match!");
            match = false;
        }
        else{
            if(!fields[0].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            else{
                if(!((String)(fields[0].getValue())).equals(tupleName)){
                    System.out.println("Wrong Tuple-Type!");
                    match = false;
                }
            }
            if(!fields[1].getType().isInstance(new Double(0))){
                System.out.println("Tuple does not match!");
                match = false;
            }
        }
        if(match){
            version = ((Double)fields[1].getValue()).doubleValue();
        }
    }
    
    public double getVersion() {
        return version;
    }
    
    public ITuple getRequestTuple() {
        Tuple tuple = new Tuple();
        Field field0 = new Field();
        Field field1 = new Field();        
        field0.setToActual(tupleName);
        if(version >= 0){
            field1.setToActual(new Double(version));
            System.out.println("Version gesetzt!");
        }else{field1.setToFormal(new Double(version).getClass());}
        tuple.add(field0);
        tuple.add(field1);
        return tuple;
    }
    
    public void setVersion(double newVersion) {
        version = newVersion;
    }
    
    public ITuple getResultTuple() {
        Tuple tuple = new Tuple();
        Field field0 = new Field();
        Field field1 = new Field();        
        field0.setToActual(tupleName);
        if(version >= 0){
            field1.setToActual(new Double(version));
        }else{field1.setToNullActual(new Double(version).getClass());}
        tuple.add(field0);
        tuple.add(field1);
        return tuple;
    }
    
}
