/*
 * MeierLeaderDecisionComponent.java
 *
 * Created on 23. Juni 2002, 02:35
 */

package casino.plugins.decision;

import casino.agents.*;
import casino.plugins.*;
import casino.plugins.game.meier.*;
import casino.plugins.whiteboard.*;
import casino.plugins.lookup.*;
import casino.misc.*;

import lime.*;
import lights.interfaces.*;
import lights.adapters.*;

import java.util.Hashtable;

/**
 *
 * @author  Administrator
 * @version 
 */
public class MeierLeaderDecisionComponent extends Thread implements DecisionPlugIn, java.io.Serializable {
    
    public static final double VERSION = 1.0;
    
    protected static final int JUST_CREATED = 0;
    public static final int READY = 1;
    protected static final int GAME_FOUND = 2;
    protected static final int NO_GAME_AVAILABLE = 3;
    public static final int GAME_HOST_REACHED = 4;
    public static final int GAME_STARTED = 5;
    public static final int GAME_ENDED = 6;
    
    public static final String LOOKUP = CommonPluginTerms.LEADER_LOOKUP_PLUGIN;
    public static final String WHITEBOARD = CommonPluginTerms.LEADER_WHITEBOARD_PLUGIN;
    public static final String MEIER = CommonPluginTerms.MEIER_LEADER_PLUGIN;
    
    protected String name = null;
    protected long ID = ID_NOT_SET;
    protected CasinoAgent agent = null;
    protected int state = JUST_CREATED;
    protected boolean active = true;
    protected Hashtable plugins = null;
    protected String migrationHost = null;
    protected boolean readyForMigration = false;
    protected LimeTupleSpace lts = null;
    protected OpQueue operationQueue = null;
    protected boolean migratable = false;
    protected int gameState = 5;

    /** Creates new MeierLeaderDecisionComponent */
    public MeierLeaderDecisionComponent() {
    }

    public CasinoAgent getAgent() {
        return agent;
    }
    
    public double getVersion() {
        return VERSION;
    }
    
    public void deactivate() {
        active = false;
    }
    
    public String getMainGame() {
        return null;
    }
    
    public void run() {
        migratable = false;
        active = true;
        readyForMigration = false;
        showMessage("Creating Meier-Game");
        while(active){
            
            try{
                sleep(100L);
            }catch(InterruptedException e){}
            
            switch(state){
                case(JUST_CREATED) : initialize();state = READY;break;
                case(READY) : 
                    
                    
                    try{
                        sleep(100L);
                    }catch(InterruptedException e){}
                    /*while(!((MeierGameLeader)getPlugin(MEIER,1.0)).isActive()){
                        try{
                            sleep(1000L);
                        }catch(InterruptedException e){}
                    }*/
                    try{
                        sleep(100L);
                    }catch(InterruptedException e){}
                    gameState = this.GAME_STARTED;
                    showMessage("Activating new Meier-Game.");
                    try{
                        //operationQueue.enqueueOp("in",new Object[]{(new MigrationToken()).getToken()});
                        ((MeierGameLeader)getPlugin(MEIER,1.0)).activate();
                        //operationQueue.enqueueOp("out",new Object[]{(new MigrationToken()).getToken()});
                    }catch(Exception e){e.printStackTrace();}
                    state = READY;
                    showMessage("Waiting for game to end.");
                    while (gameState != this.GAME_ENDED){
                        try{
                            sleep(50000L);
                        }catch(InterruptedException e){
                        }
                    }
                    try{
                        sleep(60000L);
                    }catch(InterruptedException e){
                    }
                    plugins.put(MEIER, ((MeierGameLeader)getPlugin(MEIER,1.0)).returnNewInstance());
                    showMessage("Game ended");
                    showMessage("Preparing next Meier-Game. It'll take a little time. (Muss neues Bier holen!) ;-)");
                    try{
                        sleep(10000L);
                    }catch (InterruptedException e){
                        showMessage("");
                        e.printStackTrace();
                    }
                    break;
            }            
        }        
        migratable = true;
    }
    
    public String getTyp() {
        return CommonPluginTerms.LEADER_DECISION_PLUGIN;
    }
    
    public void setCommAgent(casino.agents.CommAgent com) {
        // Hart verdrahtet, Methode nicht erforderlich fuer dieses Plugin
    }
    
    public void setState(int newState) {
        state = newState;
    }
    
    public void setID(long newID) {
        ID = newID;
    }
    
    public boolean isActive() {
        return active;
    }
    
    public Plugin getPlugin(String PluginName, double pluginVersion) {
        showMessage("Plugin erfragt: "+PluginName+" in Version "+pluginVersion);
        Plugin rueckgabe = (Plugin)plugins.get(PluginName);
        if((rueckgabe != null) && (((long)rueckgabe.getVersion() != (long)pluginVersion)||(rueckgabe.getVersion() < pluginVersion))){
            plugins.remove(PluginName);
            rueckgabe = null;
        }
        if(rueckgabe == null){
		ITuple lookupTuple = new Tuple();
		lookupTuple.addActual(PluginName);
		lookupTuple.addActual(new Double(pluginVersion));
		lookupTuple.addFormal(PluginContainer.class);
	try{
		rueckgabe = ((PluginContainer)operationQueue.enqueueOp("rdp",new Object[]{agent.getHost(),agent.getAdmin(),lookupTuple})).getPlugin();
	} catch(Exception e){e.printStackTrace();}
            plugins.put(PluginName,rueckgabe);
        }
        return rueckgabe;
    }
    
    public void activate() {
        this.start();
    }
    
    public void setTupleSpace(LimeTupleSpace TS) {
        lts = TS;
	operationQueue = new OpQueue(lts);
    }
    
    public long getID() {
        return ID;
    }
    
    public void executeQueuedOp() {
        operationQueue.executeNextQueuedOp();
    }
    
    public boolean migratable() {
        return readyForMigration;
    }
    
    public void setAgent(CasinoAgent newAgent) {
        agent = newAgent;
        if ( (agent != null) && (ID == ID_NOT_SET) ){
            this.ID = agent.getID();
        }
    }
    
    public String getPluginName() {
        return name;
    }
    
    protected void initialize() {
        plugins = new Hashtable();
        Plugin lookup = null;
	ITuple lookupTuple = new Tuple();
	lookupTuple.addActual(CommonPluginTerms.LEADER_LOOKUP_PLUGIN);
	lookupTuple.addActual(new Double(0));
	lookupTuple.addFormal(PluginContainer.class);
	try {
		PluginContainer clookup = (PluginContainer) ((ITuple)operationQueue.enqueueOp("rdp",new Object[]{agent.getHost(),agent.getAdmin(),lookupTuple})).get(2).getValue();
		lookup = clookup.getPlugin();
	} catch(Exception e) { e.printStackTrace(); }
        if(lookup != null){
            plugins.put(LOOKUP,lookup);
            showMessage("Lookup: "+LOOKUP+" Plugin: "+lookup);
            ((LookupLeaderPlugin)lookup).setLeader(this);
            lookup.activate();
            while(!lookup.isActive()){
                try{
                    sleep(100L);
                }catch(Exception e){}
            }
            showMessage("Lookup-Plugin active!");
        }
        Plugin whiteboard = null;
	ITuple whiteboardTuple = new Tuple();
	whiteboardTuple.addActual(CommonPluginTerms.LEADER_WHITEBOARD_PLUGIN);
	whiteboardTuple.addActual(new Double(0));
	whiteboardTuple.addFormal(PluginContainer.class);
	try {
		PluginContainer wlookup = (PluginContainer) ((ITuple)operationQueue.enqueueOp("rdp", new Object[]{agent.getHost(),agent.getAdmin(),whiteboardTuple})).get(2).getValue();
		whiteboard = wlookup.getPlugin();
	} catch(Exception e){ e.printStackTrace(); }
        if(whiteboard != null){
            plugins.put(WHITEBOARD, whiteboard);
	    ((WhiteboardLeaderPlugin)whiteboard).setLeader(this);
            whiteboard.activate();
            while(!whiteboard.isActive()){
                try{
                    sleep(100L);
                }catch(Exception e){}
            }
            showMessage("Whiteboard active!");
        }
        Plugin meier = null;
	ITuple meierTuple = new Tuple();
	meierTuple.addActual(CommonPluginTerms.MEIER_LEADER_PLUGIN);
	meierTuple.addActual(new Double(0));
	meierTuple.addFormal(PluginContainer.class);
	try {
		PluginContainer mlookup = (PluginContainer) ((ITuple)operationQueue.enqueueOp("rdp",new Object[]{agent.getHost(),agent.getAdmin(),meierTuple})).get(2).getValue();
		meier = mlookup.getPlugin();
	} catch(Exception e) {e.printStackTrace();}
        if(meier != null){
            plugins.put(MEIER,meier);
	    ((MeierGameLeader)meier).setDecisionPlugin(this);
            //meier.activate();
        }
        showMessage("Leader initialized!");
    }

    public LimeServer getLimeServer() {
        return agent.getLimeServer();
    }
    
    public void activate(String TSName) {
    }
    
    public void setOpQueue(OpQueue newOpQueue) {
        operationQueue = newOpQueue;
    }
    
    public void setMigrationHost(HostLocation host) {
    }
    
    public boolean readyToPlay() {
        return true;
    }
    
    public void notifyEndOfGame(int endState) {
        gameState = GAME_ENDED;
    }
    
    public boolean isMigratable() {
        return migratable;
    }
    
    
    protected void showMessage(String out){
        System.out.println("MeierLeaderDecision "+this.ID+": "+out);
    }
    
}
