/*
 * MeierGameLeader.java
 *
 * Created on 14. Juni 2002, 13:58
 */
package casino.plugins.game.meier;

import java.util.Random;
import java.util.Vector;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.io.Serializable;

import lime.*;
import lime.mobileagent.mucode.MobileAgent;
import lights.adapters.*;
import lights.interfaces.*;

import casino.terms.game.meier.MeierTerms;
import casino.agents.CommAgent;
import casino.misc.*;
import casino.misc.Timer;
import casino.agents.CommAgent;
import casino.plugins.decision.DecisionPlugIn;
import casino.plugins.whiteboard.*;
import casino.plugins.lookup.*;
import casino.plugins.CommonPluginTerms;
import casino.plugins.whiteboard.basic.*;
import casino.plugins.whiteboard.Version1_0.*;
import casino.plugins.lookup.basic.*;
import casino.plugins.lookup.version1_0.*;
import casino.plugins.game.meier.gui.MeierGameLeaderGUI;
import casino.migration.MigrationToken;

/**
 *
 * @author  sven
 * @version 1.0
 */
public class MeierGameLeader extends Thread implements casino.plugins.game.meier.MeierGameLeaderPlugin{
    
    protected static final String NAME = "Meier";
    protected static final double VERSION = 1.0;
    
    protected MeierGameLeaderGUI gui = null;
    
    protected boolean textMode = false;
    protected boolean slowMo = false;
    protected CommAgent chief = null;
    
    protected OpQueue opQueue = null;
    protected OpQueue pluginboard = null;
    
    protected CommAgent pluginboardCom = null;
    
    protected int minNumberOfPlayers = 4;
    protected int maxNumberOfPlayers = 5;
    protected int actualNumberOfPlayers = 0;
    protected int maxRounds = 10;
    protected int callForMoveCounter = 0;
    
    protected long slowMoFactor = 0L;
    
    protected Vector players = new Vector();
    protected Vector requestFromPlayersToAdd = new Vector();
    
    //protected boolean waitingTooLong = false;
    protected boolean gameIsRunning = true;
    
    protected long timeToWaitForPlayers = 3000000L;
    protected long gameCounter = 0;
    
    protected MeierTerms terms = null; 
    protected DecisionPlugIn decisionMaker = null;
    protected WBGameNachricht propagatedGame = null;
    protected LUGameMessage lookupEntry = null;
    //protected ITuple anmeldungTemplate;
    //protected ITuple anmeldungsBestaetigungTemplate;    
    protected Location myLocation = null;
    protected RegisteredReaction[] reactions = null;
    
    protected boolean migratable = false;

    /** Creates new MeierGameLeader */
    public MeierGameLeader() {
        
        terms = new MeierTerms();
        //anmeldungTemplate = terms.generateLogonTuple();
        //anmeldungsBestaetigungTemplate = terms.generateLogonAcknowledgementTuple();
    }
    
    public void activate(String TSName) {
        gameIsRunning = true;
        showMessage("Trying To activate");
        setCommAgent(CommAgent.load(decisionMaker.getLimeServer()));
        showMessage("CommAgent set");
        chief.setPluginAndTS(this, TSName);
        showMessage("CommAgent initialised");
        this.start();
        if (textMode) showMessage("activated.");
    }
    
    public void getNewField() { 
    }
    
    public void setTupleSpace(LimeTupleSpace TS) {
        if (TS.getName().equals(casino.plugins.CommonPluginTerms.PLUGINBOARD_TS_VERSION_1_0)){
            pluginboard = new OpQueue(TS);
        }else{
            showMessage("Creating opQueue");
            opQueue = new OpQueue(TS);
            showMessage("OpQueue created. Starting...");
        }
        if (textMode) showMessage("started");
    }
    
    public void run() {
        
        pluginboardCom = CommAgent.load(decisionMaker.getLimeServer());
        pluginboardCom.setPluginAndTS(new DummyPlugin(this), casino.plugins.CommonPluginTerms.PLUGINBOARD_TS_VERSION_1_0);
        while (pluginboard == null){ 
            //busy waiting
        }
        showMessage("Method run started");
        migratable = false;
        gui = new MeierGameLeaderGUI();
        gui.setLeader(this);
        gui.show();
        showMessage("gui initialised");
        gameIsRunning = true;
        while(opQueue == null){
            if (textMode) showMessage("Waiting for opQueue");
            try{
                sleep(100L);
            }catch (InterruptedException e){
                e.printStackTrace();
            }
        }
        if (!(opQueue == null)){
            
            ITuple myAgentID = terms.generateLeaderIDTuple();
            IField myIDField = new Field();
            myIDField.setToActual(chief.getMgr().getID());
            myAgentID.set(myIDField, terms.LEADERID_TUPLE_ID_POSITION );
            try{
                opQueue.enqueueOp("out", new Object[]{myLocation, myAgentID});
                if (textMode) showMessage("My ID is out.");
            }catch (NoSuchMethodException e){
                showMessage("exception occured during waiting for Players: ");
                e.printStackTrace();
            }
            if (textMode) showMessage("Game started. Waiting for Players...");
            sendMessageToGUI("Game started. Waiting for Players.");
            
            //Starte Timer fr Wartezeit auf genug Spieler
            Timer timer = new Timer(timeToWaitForPlayers, textMode);
            timer.start();
            //Erzeuge Template fr Anmeldungen
            ITuple anmeldungTemplate = terms.generateLogonTuple();
            //solange noch nicht genug Player vorhanden und noch nicht zu lange gewartet
            if (textMode) showMessage("Trying to get logon...");            
            while ((actualNumberOfPlayers < minNumberOfPlayers) && (!timer.TimeElapsed())) {
                ITuple foundTuple = null;
                //suche nach Anmeldungen.
                try{
                    foundTuple = (ITuple)opQueue.enqueueOp("inp", new Object[]{myLocation, AgentLocation.UNSPECIFIED, anmeldungTemplate});
                }catch (NoSuchMethodException e){
                    showMessage("exception occured during waiting for Players: ");
                    e.printStackTrace();
                }
                
                //Wenn keine Anmeldung gefunden 
                if (foundTuple == null){
                    //kurz warten
                    try {
                        this.sleep(100L);
                    }catch (InterruptedException e){
                        showMessage("Exception occured during waiting for Players: ");
                        e.printStackTrace();
                    }
                //sonst
                }else{
                    if (textMode) showMessage("Tuple found: "+foundTuple);
                    if (textMode) showMessage("Anmeldung erfolgt.");
                    sendMessageToGUI("Anmeldung erfolgt.");
                    //Anmeldung bearbeiten.
                    addNewPlayer(foundTuple);
                    //Wenn genug Player vorhanden, 
                    if (actualNumberOfPlayers >= maxNumberOfPlayers){
                        //dann Timer stoppen
                        //Den Eintrag fr das Spiel aus dem Whiteboard entfernen
                        ((WhiteboardLeaderPlugin)decisionMaker.getPlugin(CommonPluginTerms.LEADER_WHITEBOARD_PLUGIN, 1.0)).unpropagateGame(propagatedGame);
                        timer.stopTimer();
                    }
                }
            }
            
            
            //wenn der Timer nicht abgelaufen war:
            if (!timer.TimeElapsed()){
                
                
                //Weak Reactions auf neue Anmeldung zum TupleSpace hinzufgen, da am Spiel zustzliche Spieler mittendrin einsteigen knnen.
                try{
                    reactions = (RegisteredReaction[])opQueue.enqueueOp("addWeakReaction", new Object[]{new Reaction[] { new UbiquitousReaction(anmeldungTemplate, new NewPlayerListener(this), Reaction.ONCEPERTUPLE)}});
                }catch (NoSuchMethodException e){
                    showMessage("Exception occured: ");
                    e.printStackTrace();
                }
            
                
                //Spiel startet
                
                if (textMode) showMessage("Starting game...");
                //Das Spiel beginnen
                int round = 0;
                int turn = 0;
                int lastPropagatedResult = MeierTerms.PREDECESSOR_RESULT_START;
                int lastThrownResult = -1;
                boolean firstMove = true;
                MeierDice dice = new MeierDice();
                dice.init( (new Random()).nextLong() );
                while ( (gameIsRunning) && (round <= maxRounds) ){
                    ITuple playersTemplate = terms.generatePlayersTuple();
                    try{
                        ITuple result = (ITuple)opQueue.enqueueOp("inp", new Object[]{this.myLocation, AgentLocation.UNSPECIFIED, playersTemplate});
                    }catch (NoSuchMethodException e){
                        showMessage("");
                        e.printStackTrace();
                    }
                    
                    if (round == maxRounds-1){
                        //Spiel schon mal aus dem Whiteboard nehmen, damit sich in der letzten Runde keine Spieler mehr anmelden
                        ((WhiteboardLeaderPlugin)decisionMaker.getPlugin(CommonPluginTerms.LEADER_WHITEBOARD_PLUGIN, 1.0)).unpropagateGame(propagatedGame);
                    }
                    
                    if (round == maxRounds){
                        //Nachricht, dass Spiel beendet
                        if (textMode) showMessage("game ended here. Notifying players.");
                        sendMessageToGUI("Game ended");
                        for (int i = 0; i < players.size(); i++){
                            ITuple callForMove = terms.generateCallForMoveTuple();
                            Field playerID = new Field();
                            playerID.setToActual(((PlayerInformation)players.get(i)).getPlayerID());
                            callForMove.set(playerID, terms.CALLFORMOVE_TUPLE_PLAYER_ID_POSITION);
                            Field call = new Field();
                            call.setToActual(terms.CALLFORMOVE_ACTION_GAMEEND); 
                            callForMove.set(call, terms.CALLFORMOVE_TUPLE_ACTION_POSITION);
                            Field predecessorResult = new Field();
                            predecessorResult.setToActual(new Integer(lastPropagatedResult));
                            callForMove.set(predecessorResult, terms.CALLFORMOVE_TUPLE_PREDECESSOR_RESULT_POSITION);
                            Field callCounter = new Field();
                            callCounter.setToActual(new Integer(callForMoveCounter));
                            callForMoveCounter++;
                            callForMove.set(callCounter, terms.CALLFORMOVE_TUPLE_COUNTER_POSITION);
                            if (textMode) showMessage("Sending Message for Player"+players.get(i)+": "+callForMove);
                            try{
                                opQueue.enqueueOp("out", new Object[]{myLocation, callForMove});
                            }catch (NoSuchMethodException e){
                                showMessage("");
                                e.printStackTrace();
                            }
                            if (textMode) showMessage("Message out for Player"+players.get(i));
                        }
                        gameIsRunning = false;
                        if (textMode) showMessage("Printing out points of players");
                        for (int i = 0; i < players.size(); i++){
                            PlayerInformation outInfo = (PlayerInformation)players.get(i);
                            if (textMode) showMessage("Player: "+outInfo.getPlayerID()+", achieved Points: "+outInfo.getPoints());
                            sendMessageToGUI("Player: "+outInfo.getPlayerID()+", achieved Points: "+outInfo.getPoints());
                        }
                    }
                    
                    
                    if (gameIsRunning) { 
                        //Neue Spieler da
                        //synchronized (this){
                            if (this.requestFromPlayersToAdd.size() > 0){
                                for (int i = 0; i < this.requestFromPlayersToAdd.size(); i++){
                                    addNewPlayer((ITuple)requestFromPlayersToAdd.get(i));
                                    try{
                                        opQueue.enqueueOp("inp", new Object[]{myLocation, AgentLocation.UNSPECIFIED, (ITuple)requestFromPlayersToAdd.get(i)});
                                    }catch (NoSuchMethodException e){
                                        showMessage("");
                                        e.printStackTrace();
                                    }
                                    requestFromPlayersToAdd.remove(i--);
                                }
                                if (players.size() >= this.maxNumberOfPlayers){
                                    ((WhiteboardLeaderPlugin)decisionMaker.getPlugin(CommonPluginTerms.LEADER_WHITEBOARD_PLUGIN, 1.0)).unpropagateGame(propagatedGame);
                                }
                                ITuple playersToPropagate = terms.generatePlayersTuple();
                                IField playersV = new Field();
                                Vector playerIDs = new Vector();
                                for (int index = 0; index < players.size(); index++){
                                    PlayerInformation pInfo = (PlayerInformation)players.get(index);
                                    playerIDs.add(pInfo.getPlayerID());
                                }
                                playersV.setToActual(playerIDs);
                                playersToPropagate.set(playersV, terms.PLAYERS_TUPLE_PLAYERS_POSITION);
                                try{
                                    opQueue.enqueueOp("out", new Object[]{myLocation, playersToPropagate});
                                }catch (NoSuchMethodException e){
                                    showMessage("");
                                    e.printStackTrace();
                                }
                            }
                        //}

                        if (textMode) showMessage("Meier Round: "+round);
                        sendMessageToGUI("Meier Round: "+round);
                        
                        
                        //Den Vektor mit den SpielerIDs durchlaufen
                        //Dem Spieler mit der aktuellen ID Aufforderung zum Zug senden
                        ITuple callForMove = terms.generateCallForMoveTuple();
                        IField playerID = new Field();
                        PlayerInformation playerInfo = (PlayerInformation)players.get(turn);
                        playerID.setToActual(playerInfo.getPlayerID());
                        callForMove.set(playerID, terms.CALLFORMOVE_TUPLE_PLAYER_ID_POSITION);
                        IField call = new Field();
                        call.setToActual(terms.CALLFORMOVE_ACTION_INITIAL); 
                        callForMove.set(call, terms.CALLFORMOVE_TUPLE_ACTION_POSITION);
                        IField predecessorResult = new Field();
                        predecessorResult.setToActual(new Integer(lastPropagatedResult));
                        callForMove.set(predecessorResult, terms.CALLFORMOVE_TUPLE_PREDECESSOR_RESULT_POSITION);
                        IField callCounter = new Field();
                        callCounter.setToActual(new Integer(1));// callForMoveCounter));
                        callForMoveCounter++;
                        callForMove.set(callCounter, terms.CALLFORMOVE_TUPLE_COUNTER_POSITION);
                        if (textMode) showMessage("Sending call to move: "+callForMove+" in round: "+round);
                        try{
                            opQueue.enqueueOp("out", new Object[]{myLocation, callForMove});
                        }catch (NoSuchMethodException e){
                            showMessage("Exception occured sending Tuple to call for move: ");
                            e.printStackTrace();
                        }
                        if (textMode) showMessage("Player with ID: "+playerInfo.getPlayerID()+" called to make his move");
                        sendMessageToGUI("Player with ID: "+playerInfo.getPlayerID()+" called to make his move");
                        //Auf dessen Antwort warten und Antwort entgegennehmen
                        ITuple moveTemplate = terms.generateMoveTuple();
                        moveTemplate.set(playerID, terms.MOVE_TUPLE_PLAYER_ID_POSITION);
                        ITuple playerMove = null;
                        try{
                            playerMove = (ITuple)opQueue.enqueueOp("in", new Object[]{myLocation, AgentLocation.UNSPECIFIED, moveTemplate});
                        }catch (NoSuchMethodException e){
                            showMessage("Exception occured getting Movetuple: ");
                            e.printStackTrace();
                        }
                        if (textMode) showMessage("Move received.");
                        //Gucken, was spieler machen will
                        //wenn wuerfeln, 
                        if ( ((String)playerMove.get(terms.MOVE_TUPLE_ACTION_POSITION).getValue()).equals(terms.THROWDICE_ACTION) ){
                            //dann wuerfel an Spieler geben
                            if (textMode) showMessage("Player decided to throw dice...");
                            sendMessageToGUI("Player "+playerInfo.getPlayerID()+" decided to throw dice.");
                            try{

                                //Wuerfel erzeugen
                                //WuerfelTupel erzeugen
                                IField diceField = new Field();
                                diceField.setToActual(dice);
                                ITuple diceTuple = terms.generateDiceTuple();
                                diceTuple.set(playerID, terms.DICE_TUPLE_PLAYER_ID_POSITION);
                                diceTuple.set(diceField, terms.DICE_TUPLE_DICE_POSITION);
                                //Tupel rausgeben
                                opQueue.enqueueOp("out", new Object[]{myLocation, diceTuple});
                                if (textMode) showMessage("Dice passed to player...");

                                //Auf Aussage und Wrfel warten 
                                //dazu WuerfelTemplate erzeugen
                                ITuple diceTemplate = terms.generateDiceTuple();
                                IField myID = new Field();
                                myID.setToActual(new Long(decisionMaker.getID()));
                                diceTemplate.set(myID, terms.DICE_TUPLE_PLAYER_ID_POSITION);
                                if (textMode) showMessage("Waiting for Template: "+diceTemplate);
                                ITuple foundDice = (ITuple)opQueue.enqueueOp("in", new Object[]{myLocation, AgentLocation.UNSPECIFIED, diceTemplate});
                                if (textMode) showMessage("I 've got the dice.");

                                //PropagationTemplate erzeugen
                                ITuple propTemplate = terms.generatePropagateResultTuple();
                                propTemplate.set(myID, terms.PROPAGATE_RESULT_TUPLE_RECEIVER_ID_POSITION);
                                propTemplate.set(playerID, terms.PROPAGATE_RESULT_TUPLE_SENDER_ID_POSITION);
                                if (textMode) showMessage("Waiting for Template: "+propTemplate);
                                ITuple foundPropagation = (ITuple)opQueue.enqueueOp("in", new Object[]{myLocation, AgentLocation.UNSPECIFIED, propTemplate});

                                //Aussage und wirkliches Wrfel-Ergebnis merken
                                MeierDice receivedDice = (MeierDice)foundDice.get(terms.DICE_TUPLE_DICE_POSITION).getValue();
                                dice = receivedDice;
                                lastThrownResult = receivedDice.getLastThrow();
                                lastPropagatedResult = ((Integer)foundPropagation.get(terms.PROPAGATE_RESULT_TUPLE_RESULT_POSITION).getValue()).intValue();
                                if (textMode) showMessage("Player throwed Dice and said: "+terms.diceResultToString(lastPropagatedResult));
                                sendMessageToGUI("Player throwed Dice and said: "+terms.diceResultToString(lastPropagatedResult));

                                //Aussage publizieren
                                ITuple infoTuple = terms.generateInformationTuple();
                                infoTuple.set(playerID, terms.INFORMATION_TUPLE_ACTING_PLAYER_POSITION);
                                IField action = new Field();
                                action.setToActual(terms.THROWDICE_ACTION);
                                infoTuple.set(action, terms.INFORMATION_TUPLE_PLAYER_ACTION_POSITION);
                                IField result = new Field();
                                result.setToActual(new Integer(lastPropagatedResult));
                                infoTuple.set(result, terms.INFORMATION_TUPLE_PLAYER_ACTION_RESULT_POSITION);
                                opQueue.enqueueOp("out", new Object[]{myLocation, infoTuple});
                                if (textMode) showMessage("Informing other players of action.");
                                if (slowMo) waitOneMoment(slowMoFactor);
                            }catch (NoSuchMethodException e){
                                showMessage("Exception :");
                                e.printStackTrace();
                            }
                        }else{
                        //sonst
                            if ( ((String)playerMove.get(terms.MOVE_TUPLE_ACTION_POSITION).getValue()).equals(terms.DONT_TRUST_PREDECESSOR) && (!firstMove) ){

                                try{
                                    if (textMode) showMessage("Player decided to uncover dice.");
                                    sendMessageToGUI("Player decided to uncover dice.");
                                    //Wuerfel aufdecken 
                                    boolean uncoveringSuccessfull;
                                    //und mit Aussage des vorherigen Spielers vergleichen
                                    if (lastThrownResult == lastPropagatedResult){
                                        uncoveringSuccessfull = false;
                                        //Vorgnger hat gewonnen
                                        //Punkte zuweisen
                                        ITuple pointAssignWinner = terms.generatePointAssignmentTuple();
                                        IField winnerID = new Field();
                                        PlayerInformation playerInfoWinner;
                                        if (turn-1 < 0){
                                            playerInfoWinner = (PlayerInformation)players.get(players.size()-1);
                                            winnerID.setToActual(playerInfoWinner.getPlayerID());
                                        }else{
                                            playerInfoWinner = (PlayerInformation)players.get(turn-1);
                                            winnerID.setToActual(playerInfoWinner.getPlayerID());
                                        }
                                        playerInfoWinner.addPoints(terms.POINTS_FOR_MISLEADING_SUCCESSOR);
                                        IField winnerPoints = new Field();
                                        winnerPoints.setToActual(new Integer(terms.POINTS_FOR_MISLEADING_SUCCESSOR));
                                        pointAssignWinner.set(winnerID, terms.POINT_ASSIGNMENT_TUPLE_PLAYER_ID_POSITION);
                                        pointAssignWinner.set(winnerPoints, terms.POINT_ASSIGNMENT_TUPLE_POINTS_POSITION);
                                        opQueue.enqueueOp("out", new Object[]{myLocation, pointAssignWinner});

                                        //dem aktuellen Spieler die Punkte fr das Verlieren zuweisen.
                                        playerInfo = (PlayerInformation)players.get(turn);
                                        playerID.setToActual(playerInfo.getPlayerID());
                                        playerInfo.addPoints(terms.POINTS_FOR_UNSUCCESFULL_UNCOVERING);
                                        ITuple pointAssignLooser = terms.generatePointAssignmentTuple();
                                        IField looserPoints = new Field();
                                        looserPoints.setToActual(new Integer(terms.POINTS_FOR_UNSUCCESFULL_UNCOVERING));
                                        pointAssignLooser.set(playerID, terms.POINT_ASSIGNMENT_TUPLE_PLAYER_ID_POSITION);
                                        pointAssignLooser.set(looserPoints, terms.POINT_ASSIGNMENT_TUPLE_POINTS_POSITION);
                                        opQueue.enqueueOp("out", new Object[]{myLocation, pointAssignLooser});
                                        if (textMode){ 
                                            showMessage("Predecessor did not lie. He said "+terms.diceResultToString(lastPropagatedResult)+" and throwed "+terms.diceResultToString(lastThrownResult)+" Player "+playerID+" lost.");
                                            showMessage("Points assigned to Player (Winner) "+playerInfoWinner.getPlayerID()+": "+terms.POINTS_FOR_MISLEADING_SUCCESSOR);
                                            showMessage("Points assigned to Player (Looser) "+playerInfo.getPlayerID()+": "+terms.POINTS_FOR_UNSUCCESFULL_UNCOVERING);
                                        }
                                        sendMessageToGUI("-Predecessor did not lie. He said "+terms.diceResultToString(lastPropagatedResult)+" and throwed "+terms.diceResultToString(lastThrownResult)+" Player "+playerID+" lost.");
                                        sendMessageToGUI("-Points assigned to Player (Winner) "+playerInfoWinner.getPlayerID()+": "+terms.POINTS_FOR_MISLEADING_SUCCESSOR);
                                        sendMessageToGUI("-Points assigned to Player (Looser) "+playerInfo.getPlayerID()+": "+terms.POINTS_FOR_UNSUCCESFULL_UNCOVERING);

                                    }else{
                                        uncoveringSuccessfull = true;
                                        //aktueller Spieler hat gewonnen
                                        //Punkte zuweisen
                                        playerInfo = (PlayerInformation)players.get(turn);
                                        playerInfo.addPoints(terms.POINTS_LIE_DETECTED);
                                        playerID.setToActual(playerInfo.getPlayerID());
                                        ITuple pointAssignWinner = terms.generatePointAssignmentTuple();
                                        IField winnerPoints = new Field();
                                        winnerPoints.setToActual(new Integer(terms.POINTS_LIE_DETECTED));
                                        pointAssignWinner.set(playerID, terms.POINT_ASSIGNMENT_TUPLE_PLAYER_ID_POSITION);
                                        pointAssignWinner.set(winnerPoints, terms.POINT_ASSIGNMENT_TUPLE_POINTS_POSITION);
                                        opQueue.enqueueOp("out", new Object[]{myLocation, pointAssignWinner});

                                        ITuple pointAssignLooser = terms.generatePointAssignmentTuple();
                                        IField looserID = new Field();
                                        PlayerInformation playerInfoLooser;
                                        //Wenn erster player
                                        if (turn-1 < 0){
                                            //dann letzten benachrichtigen
                                            playerInfoLooser = (PlayerInformation)players.get(players.size()-1);
                                            looserID.setToActual(playerInfoLooser.getPlayerID());
                                        }else{
                                            //sonst Position vorher
                                            playerInfoLooser = (PlayerInformation)players.get(turn-1);
                                            looserID.setToActual(playerInfoLooser.getPlayerID());
                                        }
                                        playerInfoLooser.addPoints(terms.POINTS_LIED);
                                        IField looserPoints = new Field();
                                        looserPoints.setToActual(new Integer(terms.POINTS_LIED));
                                        pointAssignLooser.set(looserID, terms.POINT_ASSIGNMENT_TUPLE_PLAYER_ID_POSITION);
                                        pointAssignLooser.set(looserPoints, terms.POINT_ASSIGNMENT_TUPLE_POINTS_POSITION);
                                        opQueue.enqueueOp("out", new Object[]{myLocation, pointAssignLooser});

                                        if (textMode) {
                                            showMessage("Predecessor lied. He said "+terms.diceResultToString(lastPropagatedResult)+" and throwed "+terms.diceResultToString(lastThrownResult)+" Player "+playerID+" won.");
                                            showMessage("Points assigned to Player (Winner) "+playerInfo.getPlayerID()+": "+terms.POINTS_LIE_DETECTED);
                                            showMessage("Points assignde to Player (Looser) "+playerInfoLooser.getPlayerID()+": "+terms.POINTS_LIED);
                                        }
                                        sendMessageToGUI("-Predecessor lied. He said "+terms.diceResultToString(lastPropagatedResult)+" and throwed "+terms.diceResultToString(lastThrownResult)+" Player "+playerID+" won.");
                                        sendMessageToGUI("-Points assigned to Player (Winner) "+playerInfo.getPlayerID()+": "+terms.POINTS_LIE_DETECTED);
                                        sendMessageToGUI("-Points assignde to Player (Looser) "+playerInfoLooser.getPlayerID()+": "+terms.POINTS_LIED);
                                    }
                                    //Andere Spieler informieren
                                    ITuple infoTuple = terms.generateInformationTuple();
                                    infoTuple.set(playerID, terms.INFORMATION_TUPLE_ACTING_PLAYER_POSITION);
                                    IField action = new Field();
                                    action.setToActual(terms.DONT_TRUST_PREDECESSOR);
                                    infoTuple.set(action, terms.INFORMATION_TUPLE_PLAYER_ACTION_POSITION);
                                    IField result = new Field();
                                    boolean predecessorsTurn = uncoveringSuccessfull;
                                    if (uncoveringSuccessfull){
                                        result.setToActual(new Integer(terms.UNCOVERING_DICE_SUCCESFULL));
                                        //Vorgnger ist nochmal an der Reihe
                                        if (turn-1 < 0){
                                            //dann letzten benachrichtigen
                                            turn = players.size()-1;
                                        }else{
                                            //sonst Position vorher
                                            turn--;
                                        }
                                        //ID anpassen
                                        playerID = new Field();
                                        playerID.setToActual(((PlayerInformation)players.get(turn)).getPlayerID());
                                    }else{
                                        result.setToActual(new Integer(terms.UNCOVERING_DICE_UNSUCCESFULL));
                                    }
                                    infoTuple.set(result, terms.INFORMATION_TUPLE_PLAYER_ACTION_RESULT_POSITION);
                                    opQueue.enqueueOp("out", new Object[]{myLocation, infoTuple});
                                    if (textMode) showMessage("Informing other players of action. Tuple: "+infoTuple);
                                    if (slowMo) waitOneMoment(slowMoFactor);
                                    //und Aufforderung zu wuerfeln an Verlierer
                                    callForMove = terms.generateCallForMoveTuple();
                                    callForMove.set(playerID, terms.CALLFORMOVE_TUPLE_PLAYER_ID_POSITION);
                                    call = new Field();
                                    if (predecessorsTurn) {
                                        call.setToActual(terms.CALLFORMOVE_ACTION_AFTER_SUCCESSOR_UNCOVERED_DICE);
                                    }else{
                                        call.setToActual(terms.CALLFORMOVE_ACTION_AFTER_UNCOVER_DICE); 
                                    }
                                    callForMove.set(call, terms.CALLFORMOVE_TUPLE_ACTION_POSITION);
                                    predecessorResult = new Field();
                                    predecessorResult.setToActual(new Integer(MeierTerms.PREDECESSOR_RESULT_START));
                                    callForMove.set(predecessorResult, terms.CALLFORMOVE_TUPLE_PREDECESSOR_RESULT_POSITION);
                                    callCounter = new Field();
                                    callCounter.setToActual(new Integer(2));//callForMoveCounter));
                                    callForMoveCounter++;
                                    callForMove.set(callCounter, terms.CALLFORMOVE_TUPLE_COUNTER_POSITION);
                                    opQueue.enqueueOp("out", new Object[]{myLocation, callForMove});
                                    if (textMode) showMessage("Calling player "+players.get(turn)+" to move: ");
                                    sendMessageToGUI("Calling player "+((PlayerInformation)players.get(turn)).getPlayerID()+" to roll dice.");

                                    //dann wuerfel an Spieler geben
                                    
                                    //WuerfelTupel erzeugen
                                    IField diceField = new Field();
                                    diceField.setToActual(dice);
                                    ITuple diceTuple = terms.generateDiceTuple();
                                    diceTuple.set(playerID, terms.DICE_TUPLE_PLAYER_ID_POSITION);
                                    diceTuple.set(diceField, terms.DICE_TUPLE_DICE_POSITION);
                                    //Tupel rausgeben
                                    opQueue.enqueueOp("out", new Object[]{myLocation, diceTuple});
                                    if (textMode) showMessage("Dice passed to player...");

                                    //Auf Aussage warten
                                    ITuple diceTemplate = terms.generateDiceTuple();
                                    IField myID = new Field();
                                    myID.setToActual(new Long(decisionMaker.getID()));
                                    diceTemplate.set(myID, terms.DICE_TUPLE_PLAYER_ID_POSITION);
                                    ITuple foundDice = (ITuple)opQueue.enqueueOp("in", new Object[]{myLocation, AgentLocation.UNSPECIFIED, diceTemplate});

                                    //PropagationTemplate erzeugen
                                    ITuple propTemplate = terms.generatePropagateResultTuple();
                                    propTemplate.set(myID, terms.PROPAGATE_RESULT_TUPLE_RECEIVER_ID_POSITION);
                                    propTemplate.set(playerID, terms.PROPAGATE_RESULT_TUPLE_SENDER_ID_POSITION);
                                    ITuple foundPropagation = (ITuple)opQueue.enqueueOp("in", new Object[]{myLocation, AgentLocation.UNSPECIFIED, propTemplate});

                                    //Aussage und wirkliches Wrfel-Ergebnis merken
                                    MeierDice receivedDice = (MeierDice)foundDice.get(terms.DICE_TUPLE_DICE_POSITION).getValue();
                                    dice = receivedDice;
                                    lastThrownResult = receivedDice.getLastThrow();
                                    lastPropagatedResult = ((Integer)foundPropagation.get(terms.PROPAGATE_RESULT_TUPLE_RESULT_POSITION).getValue()).intValue();
                                    if (textMode) showMessage("Player throwed Dice and said: "+terms.diceResultToString(lastPropagatedResult));
                                    sendMessageToGUI("Player throwed Dice and said: "+terms.diceResultToString(lastPropagatedResult));

                                    //Aussage publizieren
                                    infoTuple = terms.generateInformationTuple();
                                    infoTuple.set(playerID, terms.INFORMATION_TUPLE_ACTING_PLAYER_POSITION);
                                    action = new Field();
                                    action.setToActual(terms.THROWDICE_ACTION);
                                    infoTuple.set(action, terms.INFORMATION_TUPLE_PLAYER_ACTION_POSITION);
                                    result = new Field();
                                    result.setToActual(new Integer(lastPropagatedResult));
                                    infoTuple.set(result, terms.INFORMATION_TUPLE_PLAYER_ACTION_RESULT_POSITION);
                                    opQueue.enqueueOp("out", new Object[]{myLocation, infoTuple});
                                    if (textMode) showMessage("Informing other players of action. Tuple: "+infoTuple);
                                }catch (NoSuchMethodException e){
                                    showMessage("");
                                    e.printStackTrace();
                                }
                                if (slowMo) waitOneMoment(slowMoFactor);
                            }
                        }
                        firstMove = false;
                        if ( (turn + 1) < players.size() ) {
                            turn++;
                        }else{
                            round++;
                            turn = 0;
                        }
                    }
                    //Wenn maximale Rundenzahl erreicht
                }
            }else{
                //Den Eintrag fr das Spiel aus dem Whiteboard entfernen
                ((WhiteboardLeaderPlugin)decisionMaker.getPlugin(CommonPluginTerms.LEADER_WHITEBOARD_PLUGIN, 1.0)).unpropagateGame(propagatedGame);
                //Bereits wartende Spieler benachrichtigen
                
                for (int i = 0; i < players.size(); i++){
                    ITuple callForMove = terms.generateCallForMoveTuple();
                    Field playerID = new Field();
                    playerID.setToActual(((PlayerInformation)players.get(i)).getPlayerID());
                    callForMove.set(playerID, terms.CALLFORMOVE_TUPLE_PLAYER_ID_POSITION);
                    Field call = new Field();
                    call.setToActual(terms.CALLFORMOVE_ACTION_GAMEEND); 
                    callForMove.set(call, terms.CALLFORMOVE_TUPLE_ACTION_POSITION);
                    Field predecessorResult = new Field();
                    predecessorResult.setToActual(new Integer(-1));
                    callForMove.set(predecessorResult, terms.CALLFORMOVE_TUPLE_PREDECESSOR_RESULT_POSITION);
                    Field callCounter = new Field();
                    callCounter.setToActual(new Integer(callForMoveCounter));
                    callForMoveCounter++;
                    callForMove.set(callCounter, terms.CALLFORMOVE_TUPLE_COUNTER_POSITION);
                    if (textMode) showMessage("Sending Message for Player"+players.get(i)+": "+callForMove);
                    try{
                        opQueue.enqueueOp("out", new Object[]{myLocation, callForMove});
                    }catch (NoSuchMethodException e){
                        showMessage("");
                        e.printStackTrace();
                    }
                    if (textMode) showMessage("Message out for Player"+players.get(i));
                }
                
                
                if (textMode) showMessage("Game stopped. Not enough Players available");
                sendMessageToGUI("Game stopped. Not enough Players available");
                //decisionMaker.notifyEndOfGame(casino.plugins.decision.MeierLeaderDecisionComponent.GAME_ENDED);
            }
        }else{
            //Den Eintrag fr das Spiel aus dem Whiteboard entfernen
                ((WhiteboardLeaderPlugin)decisionMaker.getPlugin(CommonPluginTerms.LEADER_WHITEBOARD_PLUGIN, 1.0)).unpropagateGame(propagatedGame);
            showMessage("No TupleSpace available. Game stopped");
            sendMessageToGUI("No TupleSpace availabel. Game stopped");
            //decisionMaker.notifyEndOfGame(casino.plugins.decision.MeierLeaderDecisionComponent.GAME_ENDED);
        }
        if (players.size() < maxNumberOfPlayers) System.out.println(((WhiteboardLeaderPlugin)decisionMaker.getPlugin(CommonPluginTerms.LEADER_WHITEBOARD_PLUGIN, 1.0)).unpropagateGame(propagatedGame));
        stopGame();
        try{
            sleep(10000L);
        }catch (InterruptedException e){
            showMessage("");
            e.printStackTrace();
        }
        gui.endOfGame();
        gui = null;
        decisionMaker.notifyEndOfGame(casino.plugins.decision.MeierLeaderDecisionComponent.GAME_ENDED);
        migratable = true;
    }
    
    public synchronized void addNewPlayerDuringGame(ITuple anmeldung){
        this.requestFromPlayersToAdd.add(anmeldung);
    }
    
    public synchronized void addNewPlayer(ITuple anmeldung){
        
        if (textMode) showMessage("new Player with ID "+anmeldung.get(MeierTerms.ANMELDUNG_TUPLE_PLAYER_ID_POSITION).getValue()+" tried to logon.");
        sendMessageToGUI("new Player with ID "+anmeldung.get(MeierTerms.ANMELDUNG_TUPLE_PLAYER_ID_POSITION).getValue()+" tried to logon.");

        //Besttigungstuple "bauen".
        ITuple bestaetigung = terms.generateLogonAcknowledgementTuple();

        IField idField = new Field();
        idField.setToActual((Long)anmeldung.get(terms.ANMELDUNG_TUPLE_PLAYER_ID_POSITION).getValue());
        bestaetigung.set(idField, terms.ANMELDUNGS_BESTAETIGUNG_PLAYER_ID_POSITION);       

        //Wenn noch Player zugelassen:
        if (actualNumberOfPlayers < maxNumberOfPlayers){
            if (textMode) showMessage("Adding player to player list.");
            //PlayerID in die Playerliste einfgen.
            PlayerInformation playerInfo = new PlayerInformation((Long)anmeldung.get(terms.ANMELDUNG_TUPLE_PLAYER_ID_POSITION).getValue());
            players.add(playerInfo);
            //Player ber gltige Anmeldung benachrichtigen.

            IField boolField = new Field();
            boolField.setToActual(new Boolean(terms.ANMELDUNG_BESTAETIGT));
            bestaetigung.set(boolField, terms.ANMELDUNGS_BESTAETIGUNG_BESTAETIGUNGS_POSITION);
            if (textMode) showMessage("Sending Acknowlegdment.");
            try{
                opQueue.enqueueOp("out", new Object[]{myLocation, bestaetigung});
            }catch (NoSuchMethodException e){
                showMessage("Exception occured notifying Player...");
                e.printStackTrace();
            }
            this.actualNumberOfPlayers++;
            if (textMode) showMessage("Tuple with acknowledgement of logon for Player with ID "+anmeldung.get(MeierTerms.ANMELDUNG_TUPLE_PLAYER_ID_POSITION).getValue()+" is out.");
            gui.addPlayer(playerInfo.getPlayerID());
            sendMessageToGUI("Player added.");
        //sonst 
        }else{
            //Player benachrichtigen, dass keine Anmeldung mglich
            IField boolField = new Field();
            boolField.setToActual(new Boolean(terms.ANMELDUNG_VERWEIGERT));
            bestaetigung.set(boolField, terms.ANMELDUNGS_BESTAETIGUNG_BESTAETIGUNGS_POSITION);
            if (textMode) showMessage("Denying logon.");
            try{
                opQueue.enqueueOp("out", new Object[]{myLocation, bestaetigung});
            }catch (NoSuchMethodException e){
                showMessage("Meier Game: Exception occured notifying Player...");
                e.printStackTrace();
            }

            if (textMode) showMessage("Tuple denying logon for Player with ID "+anmeldung.get(MeierTerms.ANMELDUNG_TUPLE_PLAYER_ID_POSITION).getValue()+" is out.");
            sendMessageToGUI("Too many players logon denied.");
        }
    }
    
    public String getTyp(){
        return casino.plugins.CommonPluginTerms.MEIER_LEADER_PLUGIN;
    }
    
    public void activate(){
        String TSName = new String(getName()+"-"+decisionMaker.getID()+"-"+getVersion()+"-"+gameCounter);
        gameCounter++;
        WhiteboardLeaderPlugin whiteboard = (WhiteboardLeaderPlugin)decisionMaker.getPlugin(CommonPluginTerms.LEADER_WHITEBOARD_PLUGIN, 1.0);
        propagatedGame = new WBGameNachricht(CommonPluginTerms.MEIER_GAME, "MeierLeader"+decisionMaker.getID(), decisionMaker.getID(), decisionMaker.getID(), getVersion(), TSName);
        whiteboard.propagateGame(propagatedGame);
        
        LookupLeaderPlugin lookup = (LookupLeaderPlugin)decisionMaker.getPlugin(CommonPluginTerms.LEADER_LOOKUP_PLUGIN, 1.0);
        HostLocation thisLocation = new HostLocation(decisionMaker.getLimeServer().getServerID());
        lookupEntry = new LUGameNachricht(CommonPluginTerms.MEIER_GAME, TSName, thisLocation, decisionMaker.getID(), getVersion());
        lookup.propagateGame(lookupEntry);
        activate(TSName); 
    }
    
    public void deactivate(){
        stopGame();
    }
    
    public void stopGame(){
        try{
            opQueue.enqueueOp("removeWeakReaction", new Object[]{reactions});
        }catch(NoSuchMethodException e){
            showMessage("");
            e.printStackTrace();
        }
        while (!opQueue.isEmpty()){
            try{
                sleep(10000L);
            }catch (InterruptedException e){
                showMessage("");
                e.printStackTrace();
            }
        }
        /*try{
            opQueue.enqueueOp("setShared", new Object[]{new Boolean(false)});
        }catch(NoSuchMethodException e){
            showMessage("");
            e.printStackTrace();
        }
        decisionMaker.getLimeServer().disengage();*/
        try{
            pluginboard.enqueueOp("in", new Object[]{new MigrationToken().free()});
            chief.stopComm();
            while (!chief.migrationPossible()){
                waitOneMoment(100);
            }
            chief = null;
            opQueue = null;
            propagatedGame = null;
            lookupEntry = null;
            //gui = null; Nicht hier!
            /*WhiteboardLeaderPlugin whiteboard = (WhiteboardLeaderPlugin)decisionMaker.getPlugin(CommonPluginTerms.LEADER_WHITEBOARD_PLUGIN, 1.0);
            whiteboard.unpropagateGame(propagatedGame);
            LookupLeaderPlugin lookup = (LookupLeaderPlugin)decisionMaker.getPlugin(CommonPluginTerms.LEADER_LOOKUP_PLUGIN, 1.0);
            lookup.unpropagateMessage(lookupEntry);*/
            gameIsRunning = false;
            pluginboard.enqueueOp("out", new Object[]{new MigrationToken().free()});
        }catch (NoSuchMethodException e){
            showMessage("");
            e.printStackTrace();
        }
    }
    
    public boolean isActive(){
        return gameIsRunning;
    }
    
    public int getMaxNumberOfPlayers() {
        return maxNumberOfPlayers;
    }
    
    public long getID(){
        return decisionMaker.getID();
    }
    
    public int getMinNumberOfPlayers() {
        return minNumberOfPlayers;
    }
    
    public void setMinNumberOfPlayers(int min) {
        this.minNumberOfPlayers = min;
    }
    
    public void setMaxNumberOfPlayers(int max) {
        this.maxNumberOfPlayers = max;
    }
    
    protected void showMessage(String out){
        System.out.println("Meier GameLeader "+decisionMaker.getID()+": "+out);
    }
    
    protected void sendMessageToGUI(String message){
        gui.addMessage("\n"+message);
    }
    
    public void executeQueuedOp() {
        opQueue.executeNextQueuedOp();
    }
    
    public String getPluginName() {
        return NAME;
    }
    
    public double getVersion() {
        return VERSION;
    }
    
    public void setCommAgent(casino.agents.CommAgent com) {
        this.chief = com;
        //try{
            myLocation = new AgentLocation(chief.getMgr().getID());
        /*}catch (UnknownHostException e){
            showMessage("Exception occured: ");
            e.printStackTrace();
        }*/
    }
    
    private void waitOneMoment(long time){
        try{
            sleep(time);
        }catch (InterruptedException e){
            showMessage("");
            e.printStackTrace();
        }
    }
    
    public void setDecisionPlugin(casino.plugins.decision.DecisionPlugIn decision) {
        decisionMaker = decision;
    }
    
    public void setSlowMo(boolean slowMo){
        this.slowMo = slowMo;
    }
    
    public void setSlowMoFactor(long millis) {
        if (slowMoFactor > 0){
            slowMoFactor = millis;
        }else{
            slowMoFactor = 1000;
        }
    }
    
    public void setTextMode(boolean textMode){
        this.textMode = textMode;
    }
    
    public boolean isMigratable() {
        return migratable;
    }
    
    public void notifyPlayerToShowGUI(Long playerID){
        ITuple showGUI = terms.generateShowGUITuple();
        IField id = new Field();
        id.setToActual(playerID);
        showGUI.set(id, terms.SHOW_GUI_TUPLE_PLAYERID_POSITION);
        IField flag = new Field();
        flag.setToActual(new Boolean(true));
        showGUI.set(flag, terms.SHOW_GUI_TUPLE_FLAG_POSITION);
        try{
            opQueue.enqueueOp("out", new Object[]{myLocation, showGUI});
        }catch (NoSuchMethodException e){
            showMessage("Exception occured ...");
            e.printStackTrace();
        }
        
    }
    
    public MeierGameLeaderPlugin returnNewInstance() {
        MeierGameLeader newInstance = new MeierGameLeader();
        newInstance.setDecisionPlugin(this.decisionMaker);
        newInstance.setSlowMo(slowMo);
        newInstance.setSlowMoFactor(this.slowMoFactor);
        newInstance.setTextMode(this.textMode);
        return (MeierGameLeaderPlugin)newInstance;
    }
    
    public void executeQueuedOpForPluginboard(){
        if (pluginboard != null) pluginboard.executeNextQueuedOp();
    }
    
    protected class NewPlayerListener implements ReactionListener{
        
        MeierGameLeader leader = null;
        
        public NewPlayerListener(MeierGameLeader leader){
            this.leader = leader;
        }
        
        public void reactsTo(lime.ReactionEvent reactionEvent) {
            leader.addNewPlayerDuringGame(reactionEvent.getEventTuple());
        }
        
    }
    
    
    private class PlayerInformation {
        
        private Long playerID;
        private int achievedPoints = -1;
        
        public PlayerInformation(Long playerID){
            this.playerID = playerID;
            achievedPoints = 0;
        }
        
        public int getPoints(){
            return achievedPoints;
        }
        
        public void addPoints(int points){
            achievedPoints+=points;
        }
        
        public Long getPlayerID(){
            return playerID;
        }
        
    }
    
    private class DummyPlugin implements casino.plugins.Plugin{
        
        MeierGameLeader realPlugin = null;
        
        public DummyPlugin(MeierGameLeader realPlugin){
            this.realPlugin = realPlugin;
        }
        
        public void activate() {}
        
        public void activate(String TSName) {}
        
        public void deactivate() {}
        
        public void executeQueuedOp() {
            realPlugin.executeQueuedOpForPluginboard();
        }
        
        public String getPluginName() {
            return "DummyPlugin for GameLeader to execute Methods for another TS";
        }
        
        public String getTyp() {
            return "DummyPlugin for GameLeader to execute Methods for another TS";
        }
        
        public double getVersion() {
            return realPlugin.getVersion();
        }
        
        public boolean isActive() {
            return realPlugin.isActive();
        }
        
        public boolean isMigratable() {
            return realPlugin.isMigratable();
        }
        
        public void setCommAgent(casino.agents.CommAgent com) {}
        
        public void setTupleSpace(LimeTupleSpace TS) {
            realPlugin.setTupleSpace(TS);
        }
        
    } 
    
}
