/*
 * MeierStrategyPlugin.java
 *
 * Created on 19. Juni 2002, 18:53
 */

package casino.plugins.game.meier;

import java.util.Vector;
import java.util.Random;

import lime.*;

import casino.plugins.game.Action;
import casino.terms.game.meier.MeierTerms;

/**
 *
 * @author  administrator
 * @version 
 */
public class MeierStrategyPlugin implements casino.plugins.game.meier.MeierPlayerStrategyPlugin {
    
    protected String name = "MeierStrategy";
    protected double version = 1.0;
    protected MeierTerms terms = null;
    protected Vector lastActions = new Vector();
    protected Vector meierResults = new Vector();
    //protected String myLastAction = null;

    /** Creates new MeierStrategyPlugin */
    public MeierStrategyPlugin() {
        terms = new MeierTerms();
        meierResults = terms.giveAllPossibleMeierResults();
    }

    public String getActingRecommendation(int predecessorResult) {
        
        if (predecessorResult == terms.MEIER){
            return terms.DONT_TRUST_PREDECESSOR;
        }
   
        
        if ( (predecessorResult == MeierTerms.PREDECESSOR_RESULT_START) || (lastActions.size() < 3) ){
            return terms.THROWDICE_ACTION;
        }
        //wenn die letzte beobachtete Aktion nicht der aktuellen entsprechen sollten, dann Info ber letzte noch nicht eingetroffen
        if (predecessorResult > 31){
            while ( !( ((MeierAction)lastActions.get(2)).getResultOfAction() == predecessorResult) ){
                /*try {
                    //warten bis info da.
                    wait();
                }catch (InterruptedException e){
                    e.printStackTrace();
                }*/
                //Lalala... schn busy waiting
            }
        }
        
        //Wenn ID des Players der letzten beiden Action gleich, dann hat dieser aufgedeckt und gewrfelt
        if ( ( ((MeierAction)lastActions.get(1)).getPlayerID() == ((MeierAction)lastActions.get(2)).getPlayerID() ) && ( ((MeierAction)lastActions.get(1)).getAction() != ((MeierAction)lastActions.get(2)).getAction() ) ){
            //Dann wrfeln
            return terms.THROWDICE_ACTION;
        }else{
            if ( ((MeierAction)lastActions.get(2)).getResultOfAction() <= terms.ZWEI_UND_VIERZIG){ 
                return terms.THROWDICE_ACTION;
            }else{
                Random zufall = new Random();
                if (zufall.nextFloat() < 0.7){
                    return terms.THROWDICE_ACTION;
                }else{
                    return terms.DONT_TRUST_PREDECESSOR;
                }
            }
        }
    }
    
    public String getPluginName() {
        return name;
    }
    
    public void setLastObservedAction(Action a) {
        //falls Aktion versptete beobachtet wartenden Thread wecken, da weiter oben schlafen gelegt.
        if (lastActions.size() == 3){
            lastActions.remove(0);
            lastActions.add(a);
        }else{
            lastActions.add(a);
        }
    }
    
    public void setResultOfActingRecommendation(int resultOfAction) {
    }
    
    public void executeQueuedOp() {
        //nothing to do here
    }
    
    public double getVersion() {
        return version;
    }
    
    public int getResultToPropagate(int resultOfPredecessor, int myResult) {
        if (myResult > resultOfPredecessor){
            return myResult;
        }else{
            int result = -1;
            Random zufall = new Random();
            boolean ready = false;
            while (!ready) {
                int index = (int)(zufall.nextFloat()*meierResults.size());
                if (resultOfPredecessor < ((Integer)meierResults.get(index)).intValue()){
                    ready = true;
                    result = ((Integer)meierResults.get(index)).intValue();
                }
            }
            return result;
        }
    }
    
    public void setTupleSpace(LimeTupleSpace TS) {
    }
    
    public void setCommAgent(casino.agents.CommAgent com) {
    }
    
    public void activate(String TSName) {
    }
    
    public void activate(){
    }
    
    public void setDecisionMaker(casino.plugins.decision.DecisionPlugIn decisionMaker) {
    }
    
    public boolean isActive() {
        return true;
    }
    
    public void deactivate() {
    }
    
    public String getTyp() {
        return casino.plugins.CommonPluginTerms.MEIER_STRATEGY;
    }
    
    public void lieWasDetected() {
    }
    
    public boolean isMigratable() {
        return true;
    }
    
}