/*
 * LeaderLookupPlugin.java
 *
 * Created on 17. Juni 2002, 23:36
 */

package casino.plugins.lookup;

import casino.agents.*;
import casino.plugins.lookup.version1_0.*;
import casino.plugins.lookup.basic.*;
import casino.plugins.decision.*;
import casino.misc.*;
import casino.plugins.*;

import lights.interfaces.ITuple;
import lights.interfaces.IField;
import lights.adapters.Tuple;
import lights.adapters.Field;
import lime.*;

import java.util.Vector;
import java.io.*;

/**
 *
 * @author  Administrator
 * @version 
 */
public class LeaderLookupPlugin extends Thread implements LookupLeaderPlugin,Serializable {
    
    protected String name = "LookupLeaderPlugin";
    protected static final double pluginVersion = 1.0;
    protected DecisionPlugIn leader = null;    
    protected CommAgent communicator = null;
    protected long ID = -42;
    protected OpQueue operationQueue = null;
    protected boolean active = false;
    protected boolean initialised = false;
    protected HostLocation host = null;
    protected AgentLocation agentL = null;
    protected Vector outstandings = null;
    protected boolean migratable = false;

    /** Creates new LeaderLookupPlugin */
    public LeaderLookupPlugin() {
        
    }
    
    public void activate(String TSName){
    }

    public DecisionPlugIn getLeader() {
        return leader;
    }
    
    public String getTyp(){
        return CommonPluginTerms.LEADER_LOOKUP_PLUGIN;
    }
    
    public void setCommAgent(CommAgent newCommAgent){
        communicator = newCommAgent;
    }    
    
    public void activate(){        
        this.start();
        
    }
    
    public void run(){        
        migratable = false;
        // Com-Agent initialisieren
        outstandings = new Vector();
        if(communicator == null){
            communicator = CommAgent.load(leader.getLimeServer()); 
            communicator.setPluginAndTS(this,CommonPluginTerms.LOOKUP_TS_VERSION_1_0);
        }
        while(operationQueue == null){
            try{
                sleep(50L);
            }catch(InterruptedException ie){}
        }
        active = true;
        if(!initialised){
            initialised = true;
            try{
                // Wo liegt der Lookup?
                LULookupNachricht ln = new LULookupNachricht((ITuple)operationQueue.enqueueOp("rd",new Object[]{new LULookupNachricht(null,CommonPluginTerms.LOOKUP_TS_VERSION_1_0,-5).getRequestTuple()}));
                host = ln.getPlace();
                // Wo liegt der Lookup-Admin?
                LUAdministratorNachricht an = new LUAdministratorNachricht((ITuple)operationQueue.enqueueOp("rd",new Object[]{new LUAdministratorNachricht(null,-5,CommonPluginTerms.LOOKUP_TS_VERSION_1_0,null).getRequestTuple()}));
                agentL = an.getPlace();
                // ID erfragen
                LUIDNachricht idn = new LUIDNachricht((ITuple)operationQueue.enqueueOp("in",new Object[]{new LUIDNachricht(-42).getRequestTuple()}));
                ID = idn.getID();
                // ID an Decision-Komponente weitergeben
                leader.setID(ID);
                // In Yellowpages eintragen
                operationQueue.enqueueOp("out",new Object[]{agentL,new LULeaderNachricht(leader.getPluginName(),ID,null,leader.getMainGame()).getResultTuple()});
                outstandings.add(new LULeaderNachricht(leader.getPluginName(),ID,null,CommonPluginTerms.MEIER_GAME).getResultTuple());
            }catch(Exception e){e.printStackTrace();initialised = false;}            
        }
        if(initialised){
            active = true;
            while(active){      
            try{
                sleep(1000L);            
            }catch(InterruptedException ie){}
            }
            try{
                for(int i = 0;i < outstandings.size();i++){
                    operationQueue.enqueueOp("inp",new Object[]{host,AgentLocation.UNSPECIFIED,outstandings.elementAt(i)});
                }
            }catch(Exception e){e.printStackTrace();}
        }else{
            showMessage("LeaderLookupPlugin: Fehler bei Initialisierung!");
        }        
        migratable = true;
    }
    
    public void executeQueuedOp(){
        operationQueue.executeNextQueuedOp();
    }
    
    public String getPluginName(){
        return name;
    }
    
    public void setTupleSpace(LimeTupleSpace newTuplespace){
        active = false;
        while(initialised){
            try{
                sleep(100L);
            }catch(InterruptedException e){e.printStackTrace();}
        }
        active = true;
        operationQueue = new OpQueue(newTuplespace);
    }
    
    public VersionMessage getTSVersion() {
        VersionMessage version = null;
        if(initialised){
            try{
                version = new VersionNachricht((ITuple)operationQueue.enqueueOp("rdp",new Object[]{host,AgentLocation.UNSPECIFIED,new VersionNachricht(-42).getRequestTuple()}));
            }catch(Exception e){e.printStackTrace();}
        }
        return version;
    }
    
    public void removeLookupEntry() {
        try{
            ITuple tuple = new LULeaderNachricht(leader.getPluginName(),ID,null,CommonPluginTerms.MEIER_GAME).getResultTuple();
            operationQueue.enqueueOp("inp",new Object[]{host,AgentLocation.UNSPECIFIED,tuple});
            removeOutstanding(tuple);
        }catch(Exception e){e.printStackTrace();}
    }
    
    protected void removeOutstanding(ITuple tuple){
        outstandings.remove(tuple);
    }
    
    public LUPluginboardMessage getPluginboard(LUPluginboardMessage wantedPluginboard) {
        LUPluginboardNachricht request = new LUPluginboardNachricht(wantedPluginboard.getAdminID(), wantedPluginboard.getPlace(), wantedPluginboard.getTuplespace(), wantedPluginboard.getVersion());
        LUPluginboardMessage message = null;
        try{
            message = new LUPluginboardNachricht((ITuple)operationQueue.enqueueOp("rdp",new Object[]{host,AgentLocation.UNSPECIFIED,request.getRequestTuple()}));
        }catch(Exception e){e.printStackTrace();}
        return message;
    }
    
    public LUGameTypMessage getGameTyp(LUGameTypMessage wantedGameTyp) {
        LUGameTypNachricht request = new LUGameTypNachricht(wantedGameTyp.getName(), wantedGameTyp.getVersion(), wantedGameTyp.getLeaderRule(), wantedGameTyp.getLeaderField(), wantedGameTyp.getPlayerRule(), wantedGameTyp.getPlayerStrategy());
        LUGameTypMessage message = null;
        try{
            message = new LUGameTypNachricht((ITuple)operationQueue.enqueueOp("rdp",new Object[]{host,AgentLocation.UNSPECIFIED,request.getRequestTuple()}));
        }catch(Exception e){e.printStackTrace();}
        return message;
    }
    
    public LUPlayerMessage getPlayer(LUPlayerMessage wantedPlayer) {
        LUPlayerNachricht request = new LUPlayerNachricht(wantedPlayer.getName(), wantedPlayer.getID(), wantedPlayer.getPlace(), wantedPlayer.getGame());
        LUPlayerMessage message = null;
        try{
            message = new LUPlayerNachricht((ITuple)operationQueue.enqueueOp("rdp",new Object[]{host,AgentLocation.UNSPECIFIED,request.getRequestTuple()}));
        }catch(Exception e){e.printStackTrace();}
        return message;
    }
    
    public LUWhiteboardMessage getWhiteboard(LUWhiteboardMessage wantedWhiteboard) {
        LUWhiteboardNachricht request = new LUWhiteboardNachricht(wantedWhiteboard.getAdminID(), wantedWhiteboard.getPlace(), wantedWhiteboard.getTuplespace(), wantedWhiteboard.getVersion());
        LUWhiteboardMessage message = null;
        try{
            message = new LUWhiteboardNachricht((ITuple)operationQueue.enqueueOp("rdp",new Object[]{host,AgentLocation.UNSPECIFIED,request.getRequestTuple()}));
        }catch(Exception e){e.printStackTrace();}
        return message;
    }
    
    public double getVersion() {
        return pluginVersion;
    }
    
    public void setLeader(DecisionPlugIn newLeader) {
        leader = newLeader;
    }
    
    public long getID() {
        return ID;
    }    
    
    public void deactivate() {
        active = false;
    }
    
    public void unpropagateMessage(LUGameMessage game) {
        LUGameNachricht request = new LUGameNachricht(game.getName(), game.getTuplespace(), game.getPlace(), game.getAdminID(), game.getVersion());
        removeOutstanding(request.getResultTuple());
    }
    
    public void propagateGame(LUGameMessage game) {
        LUGameNachricht request = new LUGameNachricht(game.getName(), game.getTuplespace(), game.getPlace(), game.getAdminID(), game.getVersion());
        try{
            operationQueue.enqueueOp("out",new Object[]{agentL,request.getResultTuple()});
            outstandings.add(game.getResultTuple());
        }catch(Exception e){e.printStackTrace();}
    }
    
    public LUGameMessage[] getAllGames() {
        LUGameMessage[] message = null;
        try{
            ITuple[] tuples = (ITuple[])operationQueue.enqueueOp("rdg",new Object[]{host,AgentLocation.UNSPECIFIED,new LUGameNachricht(null,null,null,-42,-42)});
            message = new LUGameMessage[tuples.length];
            for(int i = 0;i < message.length;i++){
                message[i] = new LUGameNachricht(tuples[i]);
            }
        }catch(Exception e){e.printStackTrace();}
        return message;
    }
    
    public LUGameTypMessage[] getAllGameTyps(){
        LUGameTypMessage[] message = null;
        try{
            ITuple[] tuples = (ITuple[])operationQueue.enqueueOp("rdg",new Object[]{host,AgentLocation.UNSPECIFIED,new LUGameTypNachricht(null,-42,null,null,null,null)});
            message = new LUGameTypMessage[tuples.length];
            for(int i = 0;i < message.length;i++){
                message[i] = new LUGameTypNachricht(tuples[i]);
            }
        }catch(Exception e){e.printStackTrace();}
        return message;
    }
    
    public LUPlayerMessage[] getAllPlayers() {
        LUPlayerMessage[] message = null;
        try{
            ITuple[] tuples = (ITuple[])operationQueue.enqueueOp("rdg",new Object[]{host,AgentLocation.UNSPECIFIED,new LUPlayerNachricht(null,-42,null,null)});
            message = new LUPlayerMessage[tuples.length];
            for(int i = 0;i < message.length;i++){
                message[i] = new LUPlayerNachricht(tuples[i]);
            }
        }catch(Exception e){e.printStackTrace();}
        return message;
    }
    
    public boolean isActive(){
        return active;
    }
    
    public LUAdministratorMessage getAdmin(LUAdministratorMessage adminMes) {
        LUAdministratorNachricht request = new LUAdministratorNachricht(adminMes.getName(), adminMes.getID(), adminMes.getAdministrationObject(), adminMes.getPlace());
        LUAdministratorMessage message = null;
        try{
            message = new LUAdministratorNachricht((ITuple)operationQueue.enqueueOp("rdp",new Object[]{host,AgentLocation.UNSPECIFIED,request.getRequestTuple()}));
        }catch(Exception e){e.printStackTrace();}
        return message;
    }
    
    public boolean isMigratable() {
        return migratable;
    }
    
    protected void showMessage(String out){
        System.out.println("LeaderLookupPlugin "+this.leader.getID()+": "+out);
    }
    
    
}