/*
 * PlayerLookupPlugin.java
 *
 * Created on 18. Juni 2002, 00:17
 */

package casino.plugins.lookup;

import casino.agents.*;
import casino.plugins.lookup.version1_0.*;
import casino.plugins.lookup.basic.*;
import casino.plugins.*;
import casino.plugins.decision.*;
import casino.misc.*;

import lights.interfaces.ITuple;
import lights.interfaces.IField;
import lights.adapters.Tuple;
import lights.adapters.Field;
import lime.*;

import java.util.Vector;
import java.io.*;

/**
 *
 * @author  Administrator
 * @version 
 */
public class PlayerLookupPlugin extends Thread implements LookupPlayerPlugin,Serializable {
    
    protected String name = "LookupPlayerPlugin";
    protected static final double version = 1.0;
    protected DecisionPlugIn leader = null;    
    protected CommAgent communicator = null;
    protected long ID = -42;
    protected OpQueue operationQueue = null;
    protected boolean active = false;
    protected boolean initialised = false;
    protected HostLocation host = null;
    protected AgentLocation agentL = null;
    protected Vector outstandings = null;
    protected boolean migratable = false;

    /** Creates new PlayerLookupPlugin */
    public PlayerLookupPlugin() {
        
    }

    public DecisionPlugIn getPlayer() {
        return leader;
    }
    
    protected void removeOutstanding(ITuple tuple){
        outstandings.remove(tuple);
    }
    
    public void run(){
        migratable = false;
        // Com-Agent initialisieren
        outstandings = new Vector();
        if(communicator == null){
            showMessage("Starting com: ");
            communicator = CommAgent.load(leader.getLimeServer()); 
            communicator.setPluginAndTS(this,CommonPluginTerms.LOOKUP_TS_VERSION_1_0);
        }
        showMessage("Com started.");
        while(operationQueue == null){
            try{
                sleep(50L);
            }catch(InterruptedException ie){}
        }
        showMessage("OperationQueue: "+operationQueue);
        
        if(!initialised){
            initialised = true;
            try{
                // Wo liegt der Lookup?
                showMessage("Suche Lookup-Host!");
                LULookupNachricht ln = new LULookupNachricht((ITuple)operationQueue.enqueueOp("rd",new Object[]{new LULookupNachricht(null,CommonPluginTerms.LOOKUP_TS_VERSION_1_0,-5).getRequestTuple()}));
                host = ln.getPlace();
                showMessage("Host: "+host);
                // Wo liegt der Lookup-Admin?
                LUAdministratorNachricht an = new LUAdministratorNachricht((ITuple)operationQueue.enqueueOp("rd",new Object[]{new LUAdministratorNachricht(null,-5,CommonPluginTerms.LOOKUP_TS_VERSION_1_0,null).getRequestTuple()}));
                agentL = an.getPlace();
                // ID erfragen
                if(ID < 0){
                    LUIDNachricht idn = new LUIDNachricht((ITuple)operationQueue.enqueueOp("in",new Object[]{new LUIDNachricht(-42).getRequestTuple()}));
                    ID = idn.getID();
                    // ID an Decision-Komponente weitergeben
                    leader.setID(ID);
                }
                // In Yellowpages eintragen
                operationQueue.enqueueOp("out",new Object[]{agentL,new LUPlayerNachricht(name,ID,null,leader.getMainGame()).getResultTuple()});
                outstandings.add(new LUPlayerNachricht(name,ID,null,leader.getMainGame()).getRequestTuple());
            }catch(Exception e){e.printStackTrace();initialised = false;}            
        }
        active = true;
        if(initialised){
            while(active){      
            try{
                sleep(100L);            
            }catch(InterruptedException ie){}
            }
            try{
                for(int i = 0;i < outstandings.size();i++){
                    operationQueue.enqueueOp("inp",new Object[]{host,AgentLocation.UNSPECIFIED,outstandings.elementAt(i)});
                }
            }catch(Exception e){e.printStackTrace();}
        }else{
            showMessage("LeaderLookupPlugin: Fehler bei Initialisierung!");
        }
        communicator.stopComm();
        showMessage("PlayerLookupPlugin deactivated!");
        initialised = false;         
        operationQueue = null;
        migratable = true;
        host = null;
        agentL = null;
        outstandings = null;
        migratable = true;
        active = false;
    }
    
    public double getVersion() {
        return version;
    }
    
    public void removeLookupEntry() {
        try{
            ITuple tuple = new LUPlayerNachricht(name,ID,null,leader.getMainGame()).getResultTuple();
            operationQueue.enqueueOp("inp",new Object[]{host,AgentLocation.UNSPECIFIED,tuple});
            removeOutstanding(tuple);
        }catch(Exception e){e.printStackTrace();}
    }
    
    public LUPluginboardMessage getPluginboard(LUPluginboardMessage wantedPluginboard) {
        LUPluginboardNachricht request = new LUPluginboardNachricht(wantedPluginboard.getAdminID(), wantedPluginboard.getPlace(), wantedPluginboard.getTuplespace(), wantedPluginboard.getVersion());
        LUPluginboardMessage message = null;
        try{
            message = new LUPluginboardNachricht((ITuple)operationQueue.enqueueOp("rdp",new Object[]{host,AgentLocation.UNSPECIFIED,request.getRequestTuple()}));
        }catch(Exception e){e.printStackTrace();}
        return message;
    }
    
    public LUGameTypMessage getGameTyp(LUGameTypMessage wantedGameTyp) {
        LUGameTypNachricht request = new LUGameTypNachricht(wantedGameTyp.getName(), wantedGameTyp.getVersion(), wantedGameTyp.getLeaderRule(), wantedGameTyp.getLeaderField(), wantedGameTyp.getPlayerRule(), wantedGameTyp.getPlayerStrategy());
        LUGameTypMessage message = null;
        try{
            message = new LUGameTypNachricht((ITuple)operationQueue.enqueueOp("rdp",new Object[]{host,AgentLocation.UNSPECIFIED,request.getRequestTuple()}));
        }catch(Exception e){e.printStackTrace();}
        return message;
    }
    
    public LUPlayerMessage getPlayer(LUPlayerMessage wantedPlayer) {
        LUPlayerNachricht request = new LUPlayerNachricht(wantedPlayer.getName(), wantedPlayer.getID(), wantedPlayer.getPlace(), wantedPlayer.getGame());
        LUPlayerMessage message = null;
        try{
            message = new LUPlayerNachricht((ITuple)operationQueue.enqueueOp("rdp",new Object[]{host,AgentLocation.UNSPECIFIED,request.getRequestTuple()}));
        }catch(Exception e){e.printStackTrace();}
        return message;
    }
    
    public void setAgent(DecisionPlugIn newPlayer) {
        leader = newPlayer;
    }
    
    public LUWhiteboardMessage getWhiteboard(LUWhiteboardMessage wantedWhiteboard) {
        LUWhiteboardNachricht request = new LUWhiteboardNachricht(wantedWhiteboard.getAdminID(), wantedWhiteboard.getPlace(), wantedWhiteboard.getTuplespace(), wantedWhiteboard.getVersion());
        LUWhiteboardMessage message = null;
        try{
            while(host == null){
                try{
                    sleep(100L);
                }catch(Exception e){}
            }
            message = new LUWhiteboardNachricht((ITuple)operationQueue.enqueueOp("rdp",new Object[]{host,AgentLocation.UNSPECIFIED,request.getRequestTuple()}));
        }catch(Exception e){e.printStackTrace();}
        return message;
    }
    
    public LUMigrationboardMessage getMigrationboard(LUMigrationboardMessage wantedMigrationboard) {
        LUMigrationboardNachricht request = new LUMigrationboardNachricht(wantedMigrationboard.getAdminID(), wantedMigrationboard.getPlace(), wantedMigrationboard.getTuplespace(), wantedMigrationboard.getVersion());
        LUMigrationboardMessage message = null;
        try{
            while(host == null){
                try{
                    sleep(100L);
                }catch(Exception e){}
            }
            message = new LUMigrationboardNachricht((ITuple)operationQueue.enqueueOp("rdp",new Object[]{host,AgentLocation.UNSPECIFIED,request.getRequestTuple()}));
        }catch(Exception e){e.printStackTrace();}
        return message;
    }
    
    public long createLookupEntry() {
        return ID;
    }
    
    public long getID() {
        return ID;
    }
    
    public LUGameMessage[] getAllGames() {
        LUGameMessage[] message = null;
        try{
            ITuple[] tuples = (ITuple[])operationQueue.enqueueOp("rdg",new Object[]{host,AgentLocation.UNSPECIFIED,new LUGameNachricht(null,null,null,-42,-42)});
            message = new LUGameMessage[tuples.length];
            for(int i = 0;i < message.length;i++){
                message[i] = new LUGameNachricht(tuples[i]);
            }
        }catch(Exception e){e.printStackTrace();}
        return message;
    }
    
    public LUGameTypMessage[] getAllGameTyps(){
        LUGameTypMessage[] message = null;
        try{
            ITuple[] tuples = (ITuple[])operationQueue.enqueueOp("rdg",new Object[]{host,AgentLocation.UNSPECIFIED,new LUGameTypNachricht(null,-42,null,null,null,null)});
            message = new LUGameTypMessage[tuples.length];
            for(int i = 0;i < message.length;i++){
                message[i] = new LUGameTypNachricht(tuples[i]);
            }
        }catch(Exception e){e.printStackTrace();}
        return message;
    }
    
    public LUPlayerMessage[] getAllPlayers() {
        LUPlayerMessage[] message = null;
        try{
            ITuple[] tuples = (ITuple[])operationQueue.enqueueOp("rdg",new Object[]{host,AgentLocation.UNSPECIFIED,new LUPlayerNachricht(null,-42,null,null)});
            message = new LUPlayerMessage[tuples.length];
            for(int i = 0;i < message.length;i++){
                message[i] = new LUPlayerNachricht(tuples[i]);
            }
        }catch(Exception e){e.printStackTrace();}
        return message;
    }
    
    public void deactivate() {
        System.out.println("LUPlayerPlugin: Deactivation-Message received!");
        active = false;
    }
    
    public String getTyp() {
        return CommonPluginTerms.PLAYER_LOOKUP_PLUGIN;
    }
    
    public void setCommAgent(casino.agents.CommAgent com) {
        communicator = com;
    }
    
    public void activate() {        
        this.start();
    }
    
    public void setTupleSpace(LimeTupleSpace TS) {
        active = false;
        while(initialised){
            try{
                sleep(100L);
            }catch(InterruptedException e){e.printStackTrace();}
        }
        active = true;
        operationQueue = new OpQueue(TS);        
    }
    
    public void executeQueuedOp() {
        operationQueue.executeNextQueuedOp();
    }
    
    public String getPluginName() {
        return name;
    }
    public VersionMessage getTSVersion(){
        VersionMessage version = null;
        if(initialised){
            try{
                version = new VersionNachricht((ITuple)operationQueue.enqueueOp("rdp",new Object[]{host,AgentLocation.UNSPECIFIED,new VersionNachricht(-42).getRequestTuple()}));
            }catch(Exception e){e.printStackTrace();}
        }
        return version;
    }
    
    public boolean isActive(){
        return active;
    }
    
    public void activate(String TSName){
    }
    
    public LUAdministratorMessage getAdmin(LUAdministratorMessage adminMes) {
        LUAdministratorNachricht request = new LUAdministratorNachricht(adminMes.getName(), adminMes.getID(), adminMes.getAdministrationObject(), adminMes.getPlace());
        LUAdministratorMessage message = null;
        showMessage("PlayerLookupPlugin: Hole MigragtionAdmin mit Tuple: "+request.getRequestTuple());
        try{
            message = new LUAdministratorNachricht((ITuple)operationQueue.enqueueOp("rdp",new Object[]{host,AgentLocation.UNSPECIFIED,request.getRequestTuple()}));
        }catch(Exception e){e.printStackTrace();}
        showMessage("PlayerLookupPlugin: MigrationAdmin Tuple found: "+message.getResultTuple());
        return message;
    }
    
    public LUGameMessage getGame(LUGameMessage game){
        LUGameNachricht request = new LUGameNachricht(game.getName(), game.getTuplespace(), game.getPlace(), game.getAdminID(), game.getVersion());
        LUGameMessage message = null;
        try{
            message = new LUGameNachricht((ITuple)operationQueue.enqueueOp("rdp",new Object[]{host,AgentLocation.UNSPECIFIED,request.getRequestTuple()}));
        }catch(Exception e){e.printStackTrace();}
        return message;
    }
    
    public boolean isMigratable(){
        //showMessage("Plugin finished: "+migratable);        
        boolean rueckgabe = false;
        if(communicator != null){      
            //showMessage("Communicator finished: "+communicator.migrationPossible());
            rueckgabe = (migratable) && (communicator.migrationPossible());
            if(communicator.migrationPossible()){
                communicator = null;
            }
        }else{
            rueckgabe = migratable;
        }
        return rueckgabe;
    }
    
    protected void showMessage(String out){
        System.out.println("PlayerLookupPlugin "+this.leader.getID()+": "+out);
    }
    
    
}
