/*
 * AdministratorNachricht.java
 *
 * Created on 17. Juni 2002, 11:38
 */

package casino.plugins.lookup.version1_0;

import casino.plugins.lookup.basic.*;

import lights.interfaces.ITuple;
import lights.interfaces.IField;
import lights.adapters.Tuple;
import lights.adapters.Field;
import lime.*;

/**
 *
 * @author  Administrator
 * @version 
 */
public class LUAdministratorNachricht implements LUAdministratorMessage {
    protected static final String tupleName = "AdministratorMessage";
    protected String name = null;
    protected long ID = -42;
    protected String administrationObject = null;
    protected AgentLocation place = null;

    /** Creates new AdministratorNachricht */
    public LUAdministratorNachricht(String initialName, long initialID, String initialAdministrationObject, AgentLocation initialPlace) {
        name = initialName;
        ID = initialID;
        if(initialAdministrationObject != null){
            administrationObject = initialAdministrationObject;
        }else{administrationObject = "";}
        place = initialPlace;
    }
    
    public LUAdministratorNachricht(ITuple tuple){
        boolean match = true;
        IField[] fields = tuple.getFields();
        if(fields.length != 5){
            System.out.println("Tuple-Length does not match!");
            match = false;
        }
        else{
            if(!fields[0].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            else{
                if(!((String)(fields[0].getValue())).equals(tupleName)){
                    System.out.println("Wrong Tuple-Type!");
                    match = false;
                }
            }
            if(!fields[1].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[2].getType().isInstance(new Long(0))){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[3].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[4].getType().isInstance(AgentLocation.UNSPECIFIED)){
                System.out.println("Tuple does not match!");
                match = false;
            }
        }
        if(match){
            name = (String)fields[1].getValue();
            ID = ((Long)fields[2].getValue()).longValue();
            administrationObject = (String)fields[3].getValue();
            place = (AgentLocation)fields[4].getValue();
        }
    }

    public void setAdministrationObject(String newAdministrationObject) {
        if(newAdministrationObject != null){
            administrationObject = newAdministrationObject;
        }else{administrationObject = "";}
    }
    
    public String getName() {
        return name;
    }
    
    public void setID(long newID) {
        ID = newID;
    }
    
    public AgentLocation getPlace() {
        return place;
    }
    
    public void setPlace(AgentLocation newPlace) {
        if(newPlace != null){
            place = newPlace;
        }else{place = null;}
    }
    
    public ITuple getRequestTuple() {
        Tuple tuple = new Tuple();
        Field field0 = new Field();
        Field field1 = new Field();
        Field field2 = new Field();
        Field field3 = new Field();
        Field field4 = new Field();
        field0.setToActual(tupleName);
        if(name != null){
            field1.setToActual(name);
        }
        else{
            field1.setToFormal(new String().getClass());
        }
        if(ID >= 0){
            field2.setToActual(new Long(ID));
        }
        else{
            field2.setToFormal(new Long(ID).getClass());
        }
        if(administrationObject != ""){
            field3.setToActual(administrationObject);
        }
        else{
            field3.setToFormal(administrationObject.getClass());
        }
        if(place != null){
            field4.setToActual(place);
        }else{
            field4.setToFormal(AgentLocation.UNSPECIFIED.getClass());
        }
        tuple.add(field0);
        tuple.add(field1);
        tuple.add(field2);
        tuple.add(field3);
        tuple.add(field4);
        return tuple;
    }
    
    public ITuple getResultTuple() {
        Tuple tuple = new Tuple();
        Field field0 = new Field();
        Field field1 = new Field();
        Field field2 = new Field();
        Field field3 = new Field();
        Field field4 = new Field();
        field0.setToActual(tupleName);
        if(name != ""){
            field1.setToActual(name);
        }
        else{
            field1.setToNullActual(name.getClass());
        }
        if(ID >= 0){
            field2.setToActual(new Long(ID));
        }
        else{
            field2.setToNullActual(Long.class);
        }
        if(administrationObject != ""){
            field3.setToActual(administrationObject);
        }
        else{
            field3.setToNullActual(administrationObject.getClass());
        }
        if(place != null){
            field4.setToActual(place);
        }else{
            field4.setToNullActual(AgentLocation.UNSPECIFIED.getClass());
        }
        tuple.add(field0);
        tuple.add(field1);
        tuple.add(field2);
        tuple.add(field3);
        tuple.add(field4);
        return tuple;
    }
    
    public void setName(String newName) {
        if(newName != null){
            name = newName;
        }else{name = "";}
    }
    
    public long getID() {
        return ID;
    }
    
    public String getAdministrationObject() {
        return administrationObject;
    }
    
}
