/*
 * GameNachricht.java
 *
 * Created on 17. Juni 2002, 12:20
 */

package casino.plugins.lookup.version1_0;

import casino.plugins.lookup.basic.*;

import lights.interfaces.ITuple;
import lights.interfaces.IField;
import lights.adapters.Tuple;
import lights.adapters.Field;
import lime.*;

/**
 *
 * @author  Administrator
 * @version 
 */
public class LUGameNachricht implements LUGameMessage {
    
    protected static final String tupleName = "GameMessage";
    protected String name = null;
    protected String tuplespace = null;
    protected HostLocation place = null;
    protected long administrator = -42;
    protected double version = -1;

    /** Creates new GameNachricht */
    public LUGameNachricht(String initialName, String initialTuplespace, HostLocation initialPlace, long initialAdmin, double initialVersion) {
        if(initialName != null){
            name = initialName;
        }else{ name = "";}
        if(initialTuplespace != null){
            tuplespace = initialTuplespace;
        }else{tuplespace = "";}
        place = initialPlace;
        administrator = initialAdmin;
        version = initialVersion;
    }
    
    public LUGameNachricht(ITuple tuple){
        boolean match = true;
        IField[] fields = tuple.getFields();
        if(fields.length != 6){
            System.out.println("Tuple-Length does not match!");
            match = false;
        }
        else{
            if(!fields[0].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            else{
                if(!((String)(fields[0].getValue())).equals(tupleName)){
                    System.out.println("Wrong Tuple-Type!");
                    match = false;
                }
            }
            if(!fields[1].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[2].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[3].getType().isInstance(HostLocation.UNSPECIFIED)){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[4].getType().isInstance(new Long(-1))){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[5].getType().isInstance(new Double(-1))){
                System.out.println("Tuple does not match!");
                match = false;
            }
        }
        if(match){
            name = (String)fields[1].getValue();            
            tuplespace = (String)fields[2].getValue();
            place = (HostLocation)fields[3].getValue();
            administrator = ((Long)fields[4].getValue()).longValue();
            version = ((Double)fields[5].getValue()).doubleValue();
        }
    }

    public void setAdministrator(long newAdminID) {
        administrator = newAdminID;
    }
    
    public double getVersion() {
        return version;
    }
    
    public void setTuplespace(String newSpace) {
        if(newSpace != null){
            tuplespace = newSpace;
        }else{tuplespace = "";}
    }
    
    public String getName() {
        return name;
    }
    
    public HostLocation getPlace() {
        return place;
    }
    
    public void setPlace(HostLocation newPlace) {
        place = newPlace;
    }
    
    public ITuple getRequestTuple() {
        Tuple tuple = new Tuple();
        Field field0 = new Field();
        Field field1 = new Field();
        Field field2 = new Field();
        Field field3 = new Field();
        Field field4 = new Field();
        Field field5 = new Field();
        field0.setToActual(tupleName);
        if(name != ""){
            field1.setToActual(name);
        }else{
            field1.setToFormal(name.getClass());
        }
        if(tuplespace != ""){
            field2.setToActual(tuplespace);
        }else{
            field2.setToFormal(tuplespace.getClass());
        }
        if(place != null){
            field3.setToActual(place);
        }else{
            field3.setToFormal(HostLocation.UNSPECIFIED.getClass());
        }
        if(administrator >= 0){
            field4.setToActual(new Long(administrator));
        }else{
            field4.setToFormal(new Long(administrator).getClass());
        }
        if(version >= 0){
            field5.setToActual(new Double(version));
        }else{
            field5.setToFormal(new Double(version).getClass());
        }
        tuple.add(field0);
        tuple.add(field1);
        tuple.add(field2);
        tuple.add(field3);
        tuple.add(field4);
        tuple.add(field5);
        return tuple;
    }
    
    public ITuple getResultTuple() {
        Tuple tuple = new Tuple();
        Field field0 = new Field();
        Field field1 = new Field();
        Field field2 = new Field();
        Field field3 = new Field();
        Field field4 = new Field();
        Field field5 = new Field();
        field0.setToActual(tupleName);
        if(name != ""){
            field1.setToActual(name);
        }else{
            field1.setToNullActual(name.getClass());
        }
        if(tuplespace != ""){
            field2.setToActual(tuplespace);
        }else{
            field2.setToNullActual(tuplespace.getClass());
        }
        if(place != null){
            field3.setToActual(place);
        }else{
            field3.setToNullActual(HostLocation.UNSPECIFIED.getClass());
        }
        if(administrator >= 0){
            field4.setToActual(new Long(administrator));
        }else{
            field4.setToNullActual(new Long(administrator).getClass());
        }
        if(version >= 0){
            field5.setToActual(new Double(version));
        }else{
            field5.setToNullActual(new Double(version).getClass());
        }
        tuple.add(field0);
        tuple.add(field1);
        tuple.add(field2);
        tuple.add(field3);
        tuple.add(field4);
        tuple.add(field5);
        return tuple;
    }
    
    public void setName(String newName) {
        if(newName != null){
            name = newName;
        }else{name = "";}
    }
    
    public String getTuplespace() {
        return tuplespace;
    }
    
    public void setVersion(double newVersion) {
        version = newVersion;
    }
    
    public long getAdminID() {
        return administrator;
    }    
}
