/*
 * GameTypNachricht.java
 *
 * Created on 17. Juni 2002, 12:59
 */

package casino.plugins.lookup.version1_0;

import casino.plugins.lookup.basic.*;

import lights.interfaces.ITuple;
import lights.interfaces.IField;
import lights.adapters.Tuple;
import lights.adapters.Field;

/**
 *
 * @author  Administrator
 * @version 
 */
public class LUGameTypNachricht implements LUGameTypMessage {
    protected static final String tupleName = "GameTypMessage";
    protected String name = null;
    protected double version = -1;
    protected String leaderRules = null;
    protected String leaderField = null;
    protected String playerRules = null;
    protected String playerStrategy = null;

    /** Creates new GameTypNachricht */
    public LUGameTypNachricht(String initialName, double initialVersion, String initialLeaderRules, String initialLeaderField, String initialPlayerRules, String initialPlayerStrategy) {
        if(initialName != null){
            name = initialName;
        }else{name = "";}
        version = initialVersion;
        if(initialLeaderRules != null){
            leaderRules = initialLeaderRules;
        }else{leaderRules = "";}
        if(initialLeaderField != null){
            leaderField = initialLeaderField;
        }else{leaderField = "";}
        if(initialPlayerRules != null){
            playerRules = initialPlayerRules;
        }else{playerRules = "";}
        if(initialPlayerStrategy != null){
            playerStrategy = initialPlayerStrategy;
        }else{playerStrategy = "";}
    }
    
    public LUGameTypNachricht(ITuple tuple){
         boolean match = true;
        IField[] fields = tuple.getFields();
        if(fields.length != 7){
            System.out.println("Tuple-Length does not match!");
            match = false;
        }
        else{
            if(!fields[0].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            else{
                if(!((String)(fields[0].getValue())).equals(tupleName)){
                    System.out.println("Wrong Tuple-Type!");
                    match = false;
                }
            }
            if(!fields[1].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[2].getType().isInstance(new Double(0))){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[3].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[4].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[5].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[6].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
        }
        if(match){
            name = (String)fields[1].getValue();
            version = ((Double)fields[2].getValue()).doubleValue();
            leaderRules = (String)fields[3].getValue();
            leaderField = (String)fields[4].getValue();
            playerRules = (String)fields[5].getValue();
            playerStrategy = (String)fields[6].getValue();
        }
    }

    public void setLeaderField(String newLeaderField) {
        if(newLeaderField != null){
            leaderField = newLeaderField;
        }else{leaderField = "";}
    }
    
    public double getVersion() {
        return version;
    }
    
    public void setPlayerRule(String newPlayerRule) {
        if(newPlayerRule != null){
            playerRules = newPlayerRule;
        }else{playerRules = "";}
    }
    
    public String getName() {
        return name;
    }
    
    public String getLeaderField() {
        return leaderField;
    }
    
    public void setLeaderRule(String newLeaderRule) {
        if(newLeaderRule != null){
            leaderRules = newLeaderRule;
        }else{leaderRules = "";}
    }
    
    public ITuple getRequestTuple() {
        Tuple tuple = new Tuple();
        Field field0 = new Field();
        Field field1 = new Field();
        Field field2 = new Field();
        Field field3 = new Field();
        Field field4 = new Field();
        Field field5 = new Field();
        Field field6 = new Field();
        field0.setToActual(tupleName);
        if(name != ""){
            field1.setToActual(name);
        }else{
            field1.setToFormal(name.getClass());
        }
        if(version >= 0){
            field2.setToActual(new Double(version));
        }else{
            field2.setToFormal(new Double(version).getClass());
        }
        if(leaderRules != ""){
            field3.setToActual(leaderRules);
        }else{
            field3.setToFormal(leaderRules.getClass());
        }
        if(leaderField != ""){
            field4.setToActual(leaderField);
        }else{
            field4.setToFormal(leaderField.getClass());
        }
        if(playerRules != ""){
            field5.setToActual(playerRules);
        }else{
            field5.setToFormal(playerRules.getClass());
        }
        if(playerStrategy != ""){
            field6.setToActual(playerStrategy);
        }else{
            field6.setToFormal(playerStrategy.getClass());
        }
        tuple.add(field0);
        tuple.add(field1);
        tuple.add(field2);
        tuple.add(field3);
        tuple.add(field4);
        tuple.add(field5);
        tuple.add(field6);
        return tuple;
    }
    
    public ITuple getResultTuple() {
        Tuple tuple = new Tuple();
        Field field0 = new Field();
        Field field1 = new Field();
        Field field2 = new Field();
        Field field3 = new Field();
        Field field4 = new Field();
        Field field5 = new Field();
        Field field6 = new Field();
        field0.setToActual(tupleName);
        if(name != ""){
            field1.setToActual(name);
        }else{
            field1.setToNullActual(name.getClass());
        }
        if(version >= 0){
            field2.setToActual(new Double(version));
        }else{
            field2.setToNullActual(new Double(version).getClass());
        }
        if(leaderRules != ""){
            field3.setToActual(leaderRules);
        }else{
            field3.setToNullActual(leaderRules.getClass());
        }
        if(leaderField != ""){
            field4.setToActual(leaderField);
        }else{
            field4.setToNullActual(leaderField.getClass());
        }
        if(playerRules != ""){
            field5.setToActual(playerRules);
        }else{
            field5.setToNullActual(playerRules.getClass());
        }
        if(playerStrategy != ""){
            field6.setToActual(playerStrategy);
        }else{
            field6.setToNullActual(playerStrategy.getClass());
        }
        tuple.add(field0);
        tuple.add(field1);
        tuple.add(field2);
        tuple.add(field3);
        tuple.add(field4);
        tuple.add(field5);
        tuple.add(field6);
        return tuple;
    }
    
    public void setName(String newName) {
        if(newName != null){
            name = newName;
        }else{name = "";}
    }
    
    public String getPlayerStrategy() {
        return playerStrategy;
    }
    
    public String getLeaderRule() {
        return leaderRules;
    }
    
    public void setPlayerStrategy(String newPlayerStrategie) {
        if(newPlayerStrategie != null){
            playerStrategy = newPlayerStrategie;
        }else{playerStrategy = "";}
    }
    
    public String getPlayerRule() {
        return playerRules;
    }
    
    public void setVersion(double newVersion) {
        version = newVersion;
    }
    
}
