/*
 * IDNachricht.java
 *
 * Created on 17. Juni 2002, 23:04
 */

package casino.plugins.lookup.version1_0;

import casino.plugins.lookup.basic.*;

import lights.interfaces.ITuple;
import lights.interfaces.IField;
import lights.adapters.Tuple;
import lights.adapters.Field;

/**
 *
 * @author  Administrator
 * @version 
 */
public class LUIDNachricht implements LUIDMessage {
    
    protected static final String tupleName = "LeaderMessage"; 
    protected long ID = -42;

    /** Creates new IDNachricht */
    public LUIDNachricht(long initialID) {
        ID = initialID;
    }
    
    public LUIDNachricht(ITuple tuple){
        boolean match = true;
        IField[] fields = tuple.getFields();
        if(fields.length != 2){
            System.out.println("Tuple-Length does not match!");
            match = false;
        }
        else{
            if(!fields[0].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            else{
                if(!((String)(fields[0].getValue())).equals(tupleName)){
                    System.out.println("Wrong Tuple-Type!");
                    match = false;
                }
            }
            if(!fields[1].getType().isInstance(new Long(0))){
                System.out.println("Tuple does not match!");
                match = false;
            }
        }
        if(match){
            ID = ((Long)fields[1].getValue()).longValue();
        }
    }

    public void setID(long newID) {
        ID = newID;
    }
    
    public ITuple getRequestTuple() {
        Tuple tuple = new Tuple();
        Field field0 = new Field();
        Field field1 = new Field();        
        field0.setToActual(tupleName);
        if(ID >= 0){
            field1.setToActual(new Long(ID));
        }else{field1.setToFormal(new Long(ID).getClass());}
        tuple.add(field0);
        tuple.add(field1);
        return tuple;
    }

    public ITuple getResultTuple() {
        Tuple tuple = new Tuple();
        Field field0 = new Field();
        Field field1 = new Field();        
        field0.setToActual(tupleName);
        if(ID >= 0){
            field1.setToActual(new Long(ID));
        }else{field1.setToNullActual(new Long(ID).getClass());}
        tuple.add(field0);
        tuple.add(field1);
        return tuple;
    }
    
    public long getID() {
        return ID;
    }   
}