/*
 * LeaderNachricht.java
 *
 * Created on 17. Juni 2002, 13:26
 */

package casino.plugins.lookup.version1_0;

import casino.plugins.lookup.basic.*;

import lights.interfaces.ITuple;
import lights.interfaces.IField;
import lights.adapters.Tuple;
import lights.adapters.Field;
import lime.*;

/**
 *
 * @author  Administrator
 * @version 
 */
public class LULeaderNachricht implements LULeaderMessage {
    
    protected static final String tupleName = "LeaderMessage";    
    protected String name = null;
    protected long ID = -42;
    protected HostLocation place = null;
    protected String game = null;
    
    /** Creates new LeaderNachricht */
    public LULeaderNachricht(String initialName, long initialID, HostLocation initialPlace, String initialGame) {
        if(initialName != null){
            name = initialName;
        }else{name = "";}
        ID = initialID;
        place = initialPlace;
        if(initialGame != null){
            game = initialGame;
        }else{game = "";}
    }
    
    public LULeaderNachricht(ITuple tuple){
        boolean match = true;
        IField[] fields = tuple.getFields();
        if(fields.length != 5){
            System.out.println("Tuple-Length does not match!");
            match = false;
        }
        else{
            if(!fields[0].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            else{
                if(!((String)(fields[0].getValue())).equals(tupleName)){
                    System.out.println("Wrong Tuple-Type!");
                    match = false;
                }
            }
            if(!fields[1].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[2].getType().isInstance(new Long(0))){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[3].getType().isInstance(HostLocation.UNSPECIFIED)){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[4].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
        }
        if(match){
            name = (String)fields[1].getValue();
            ID = ((Long)fields[2].getValue()).longValue();
            place = (HostLocation)fields[3].getValue();
            game = (String)fields[4].getValue();
        }
    }

    public String getGame() {
        return game;
    }
    
    public String getName() {
        return name;
    }
    
    public void setID(long newID) {
        ID = newID;
    }
    
    public HostLocation getPlace() {
        return place;
    }
    
    public void setPlace(HostLocation newPlace) {
        place = newPlace;
    }
    
    public ITuple getRequestTuple() {
        Tuple tuple = new Tuple();
        Field field0 = new Field();
        Field field1 = new Field();
        Field field2 = new Field();
        Field field3 = new Field();
        Field field4 = new Field();
        field0.setToActual(tupleName);
        if(name != ""){
            field1.setToActual(name);
        }else{
            field1.setToFormal(name.getClass());
        }
        if(ID >= 0){
            field2.setToActual(new Long(ID));
        }else{field2.setToFormal(new Long(ID).getClass());}
        if(place != null){
            field3.setToActual(place);
        }else{field3.setToFormal(HostLocation.UNSPECIFIED.getClass());}
        if(game != ""){
            field4.setToActual(game);
        }else{
            field4.setToFormal(game.getClass());
        }
        tuple.add(field0);
        tuple.add(field1);
        tuple.add(field2);
        tuple.add(field3);
        tuple.add(field4);
        return tuple;
    }
    
    public ITuple getResultTuple() {
        Tuple tuple = new Tuple();
        Field field0 = new Field();
        Field field1 = new Field();
        Field field2 = new Field();
        Field field3 = new Field();
        Field field4 = new Field();
        field0.setToActual(tupleName);
        if(name != ""){
            field1.setToActual(name);
        }else{
            field1.setToNullActual(name.getClass());
        }
        if(ID >= 0){
            field2.setToActual(new Long(ID));
        }else{field2.setToNullActual(new Long(ID).getClass());}
        if(place != null){
            field3.setToActual(place);
        }else{field3.setToNullActual(HostLocation.UNSPECIFIED.getClass());}
        if(game != ""){
            field4.setToActual(game);
        }else{
            field4.setToNullActual(game.getClass());
        }
        tuple.add(field0);
        tuple.add(field1);
        tuple.add(field2);
        tuple.add(field3);
        tuple.add(field4);
        return tuple;
    }
    
    public void setName(String newName) {
        if(newName != null){
            name = newName;
        }else{name = "";}
    }
    
    public void setGame(String newGame) {
        if(newGame != null){
            game = newGame;
        }else{game = "";}
    }
    
    public long getID() {
        return ID;
    }
    
}
