/*
 * LookupNachricht.java
 *
 * Created on 17. Juni 2002, 13:39
 */

package casino.plugins.lookup.version1_0;

import casino.plugins.lookup.basic.*;

import lights.interfaces.ITuple;
import lights.interfaces.IField;
import lights.adapters.Tuple;
import lights.adapters.Field;
import lime.*;

/**
 *
 * @author  Administrator
 * @version 
 */
public class LULookupNachricht implements LULookupMessage {
    
    protected static final String tupleName = "LookupMessage";
    protected HostLocation place = null;
    protected String tuplespace = null;
    protected long adminID = -42;

    /** Creates new LookupNachricht */
    public LULookupNachricht(HostLocation initialPlace, String initialTuplespace, long initialAdminID) {
        place = initialPlace;
        if(initialTuplespace != null){
            tuplespace = initialTuplespace;
        }else{tuplespace = "";}
        adminID = initialAdminID;
    }
    
    public LULookupNachricht(ITuple tuple){
        boolean match = true;
        IField[] fields = tuple.getFields();
        if(fields.length != 4){
            System.out.println("Tuple-Length does not match!");
            match = false;
        }
        else{
            if(!fields[0].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            else{
                if(!((String)(fields[0].getValue())).equals(tupleName)){
                    System.out.println("Wrong Tuple-Type!");
                    match = false;
                }
            }
            if(!fields[1].getType().isInstance(HostLocation.UNSPECIFIED)){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[2].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[3].getType().isInstance(new Long(-42))){
                System.out.println("Tuple does not match!");
                match = false;
            }            
        }
        if(match){
            place = (HostLocation)fields[1].getValue();            
            tuplespace = (String)fields[2].getValue();
            adminID = ((Long)fields[3].getValue()).longValue();
        }
    }

    public void setAdminID(long newAdminID) {
        adminID = newAdminID;
    }
    
    public void setTuplespace(String newSpace) {
        if(newSpace != null){
            tuplespace = newSpace;
        }else{ tuplespace = "";}
    }
    
    public HostLocation getPlace() {
        return place;
    }
    
    public void setPlace(HostLocation newPlace) {
        place = newPlace;
    }
    
    public ITuple getRequestTuple() {
        Tuple tuple = new Tuple();
        Field field0 = new Field();
        Field field1 = new Field();
        Field field2 = new Field();
        Field field3 = new Field();
        field0.setToActual(tupleName);
        if(place != null){
            field1.setToActual(place);
        }else{
            field1.setToFormal(HostLocation.UNSPECIFIED.getClass());
        }
        if(tuplespace != ""){
            field2.setToActual(tuplespace);
        }else{
            field2.setToFormal(tuplespace.getClass());
        }
        if(adminID >= 0){
            field3.setToActual(new Long(adminID));
        }else{
            field3.setToFormal(new Long(adminID).getClass());
        }
        tuple.add(field0);
        tuple.add(field1);
        tuple.add(field2);
        tuple.add(field3);
        return tuple;
    }

    public ITuple getResultTuple() {
        Tuple tuple = new Tuple();
        Field field0 = new Field();
        Field field1 = new Field();
        Field field2 = new Field();
        Field field3 = new Field();
        field0.setToActual(tupleName);
        if(place != null){
            field1.setToActual(place);
        }else{
            field1.setToNullActual(HostLocation.UNSPECIFIED.getClass());
        }
        if(tuplespace != ""){
            field2.setToActual(tuplespace);
        }else{
            field2.setToNullActual(tuplespace.getClass());
        }
        if(adminID >= 0){
            field3.setToActual(new Long(adminID));
        }else{
            field3.setToNullActual(new Long(adminID).getClass());
        }
        tuple.add(field0);
        tuple.add(field1);
        tuple.add(field2);
        tuple.add(field3);
        return tuple;
    }
    
    public String getTuplespace() {
        return tuplespace;
    }
    
    public long getAdminID() {
        return adminID;
    }
    
}
