/*
 * WhiteboardNachricht.java
 *
 * Created on 17. Juni 2002, 22:35
 */

package casino.plugins.lookup.version1_0;

import casino.plugins.lookup.basic.*;

import lights.interfaces.ITuple;
import lights.interfaces.IField;
import lights.adapters.Tuple;
import lights.adapters.Field;
import lime.*;

/**
 *
 * @author  Administrator
 * @version 
 */
public class LUWhiteboardNachricht implements LUWhiteboardMessage {
    
    protected static final String tupleName = "WhiteboardMessage";
    protected long adminID = -42;
    protected HostLocation place = null;
    protected String tuplespace = null;
    protected double version = -42;

    /** Creates new WhiteboardNachricht */
    public LUWhiteboardNachricht(long initialAdminID, HostLocation initialPlace, String initialSpace, double initialVersion) {
        adminID = initialAdminID;
        place = initialPlace;            
        if(initialSpace != null){
            tuplespace = initialSpace;
        }else{tuplespace = "";}
        version = initialVersion;
    }
    
    public LUWhiteboardNachricht(ITuple tuple){
        boolean match = true;
        IField[] fields = tuple.getFields();
        if(fields.length != 5){
            System.out.println("Tuple-Length does not match!");
            match = false;
        }
        else{
            if(!fields[0].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            else{
                if(!((String)(fields[0].getValue())).equals(tupleName)){
                    System.out.println("Wrong Tuple-Type!");
                    match = false;
                }
            }
            if(!fields[1].getType().isInstance(new Long(0))){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[2].getType().isInstance(HostLocation.UNSPECIFIED)){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[3].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[4].getType().isInstance(new Double(0))){
                System.out.println("Tuple does not match!");
                match = false;
            }
        }
        if(match){
            adminID = ((Long)fields[1].getValue()).longValue();
            place = (HostLocation)fields[2].getValue();
            tuplespace = (String)fields[3].getValue();
            version = ((Double)fields[4].getValue()).doubleValue();
            if(tuplespace == null){tuplespace = "";}
        }
    }

    public long getAdminID() {
        return adminID;
    }
    
    public HostLocation getPlace() {
        return place;
    }    
    
    public ITuple getRequestTuple() {
        /*protected long adminID = -42;
        protected String place = null;
        protected String tuplespace = null;
        protected double version = -42;
         */
        Tuple tuple = new Tuple();
        Field field0 = new Field();
        Field field1 = new Field();
        Field field2 = new Field();
        Field field3 = new Field();
        Field field4 = new Field();
        field0.setToActual(tupleName);
        if(adminID >= 0){
            field1.setToActual(new Long(adminID));
        }else{
            field1.setToFormal(new Long(adminID).getClass());
        }
        if(place != null){            
            field2.setToActual(place);
        }else{
            field2.setToFormal(HostLocation.UNSPECIFIED.getClass());
        }
        if(tuplespace != ""){
            field3.setToActual(tuplespace);
        }else{
            field3.setToFormal(tuplespace.getClass());
        }
        if(version >= 0){
            field4.setToActual(new Double(version));
        }else{
            field4.setToFormal(new Double(version).getClass());
        }
        tuple.add(field0);
        tuple.add(field1);
        tuple.add(field2);
        tuple.add(field3);
        tuple.add(field4);
        return tuple;
    }

        public ITuple getResultTuple() {
        /*protected long adminID = -42;
        protected String place = null;
        protected String tuplespace = null;
        protected double version = -42;
         */
        Tuple tuple = new Tuple();
        Field field0 = new Field();
        Field field1 = new Field();
        Field field2 = new Field();
        Field field3 = new Field();
        Field field4 = new Field();
        field0.setToActual(tupleName);
        if(adminID >= 0){
            field1.setToActual(new Long(adminID));
        }else{
            field1.setToNullActual(new Long(adminID).getClass());
        }
        if(place != null){            
            field2.setToActual(place);
        }else{
            field2.setToNullActual(HostLocation.UNSPECIFIED.getClass());
        }
        if(tuplespace != ""){
            field3.setToActual(tuplespace);
        }else{
            field3.setToNullActual(tuplespace.getClass());
        }
        if(version >= 0){
            field4.setToActual(new Double(version));
        }else{
            field4.setToNullActual(new Double(version).getClass());
        }
        tuple.add(field0);
        tuple.add(field1);
        tuple.add(field2);
        tuple.add(field3);
        tuple.add(field4);
        return tuple;
    }
    
    public String getTuplespace() {
        return tuplespace;
    }
    
    public double getVersion() {
        return version;
    }
    
    public void setAdminID(long newAdminID) {
        adminID = newAdminID;
    }
    
    public void setPlace(HostLocation newPlace) {
        place = newPlace;
    }
    
    public void setTuplespace(String newSpace) {
        if(newSpace != null){
            tuplespace = newSpace;
        }else{tuplespace = "";}
    }
    
    public void setVersion(double newVersion) {
        version = newVersion;
    }
    
}
