/*
 * GameNachricht.java
 *
 * Created on 21. Juni 2002, 22:56
 */

package casino.plugins.whiteboard.Version1_0;

import casino.plugins.whiteboard.basic.*;

import lights.interfaces.*;
import lights.adapters.*;

/**
 *
 * @author  jens
 * @version 
 */
public class WBGameNachricht implements WBGameMessage {
    protected static final String messageName = "GameMessage";
    protected static final int NOT_SPECIFIED = -42;
    protected static final double NO_VERSION = -42;
    protected long fieldID = NOT_SPECIFIED;
    protected long leaderID = NOT_SPECIFIED;
    protected String gameName = null;
    protected String leaderName = null;
    protected double version = NO_VERSION;
    protected String tuplespace = null;

    /** Creates new GameNachricht */
    public WBGameNachricht(String initialGameName, String initialLeaderName, long initialLeaderID, long initialFieldID, double initialVersion, String initialTuplespace) {
        if(initialGameName != null){
            gameName = initialGameName;
        }
        if(initialLeaderName != null){
            leaderName = initialLeaderName;
        }
        if(initialLeaderID >= 0){
            leaderID = initialLeaderID;
        }
        if(initialFieldID >= 0){
            fieldID = initialFieldID;
        }
        if(initialVersion >= 0){
            version = initialVersion;
        }
        if(initialTuplespace != null){
            tuplespace = initialTuplespace;
        }
    }
    
    public WBGameNachricht(ITuple tuple){
        boolean match = true;
        IField[] fields = tuple.getFields();
        if(fields.length != 7){
            System.out.println("Tuple-Length does not match!");
            match = false;
        }
        else{
            if(!fields[0].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            else{
                if(!((String)(fields[0].getValue())).equals(messageName)){
                    System.out.println("Wrong Tuple-Type!");
                    match = false;
                }
            }
            if(!fields[1].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[2].getType().isInstance(new Double(0))){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[3].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[4].getType().isInstance(new Long(0))){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[5].getType().isInstance(new Long(0))){
                System.out.println("Tuple does not match!");
                match = false;
            }
            if(!fields[6].getType().isInstance(new String())){
                System.out.println("Tuple does not match!");
                match = false;
            }
        }
        if(match){
            gameName = (String)fields[1].getValue();
            version = ((Double)fields[2].getValue()).doubleValue();
            leaderName = (String)fields[3].getValue();
            leaderID = ((Long)fields[4].getValue()).longValue();
            fieldID = ((Long)fields[5].getValue()).longValue();
            tuplespace = (String)fields[6].getValue();
        }
    }

    public long getFieldID() {
        return fieldID;
    }
    
    public long getLeaderID() {
        return leaderID;
    }
    
    public String getTuplespace() {
        return tuplespace;
    }
    
    public String getGameName() {
        return gameName;
    }
    
    public double getVersion() {
        return version;
    }
    
    public ITuple getRequestTuple() {
        Tuple tuple = new Tuple();
        tuple.addActual(messageName);
        if(gameName == null){
            tuple.addFormal(new String().getClass());
        }else{
            tuple.addActual(gameName);
        }
        if(version == NO_VERSION){
            tuple.addFormal(new Double(0).getClass());
        }else{
            tuple.addActual(new Double(version));
        }
        if(leaderName == null){
            tuple.addFormal(new String().getClass());
        }else{
            tuple.addActual(leaderName);
        }
        if(leaderID == NOT_SPECIFIED){
            tuple.addFormal(new Long(0).getClass());
        }else{
            tuple.addActual(new Long(leaderID));
        }
        if(fieldID == NOT_SPECIFIED){
            tuple.addFormal(new Long(0).getClass());
        }else{
            tuple.addActual(new Long(fieldID));
        }        
        if(tuplespace == null){
            tuple.addFormal(new String().getClass());
        }else{
            tuple.addActual(tuplespace);
        }
        return tuple;
    }
    
    public ITuple getResultTuple() {
        Tuple tuple = new Tuple();
        tuple.addActual(messageName);
        if(gameName == null){
            tuple.add(new Field().setToNullActual(new String().getClass()));
        }else{
            tuple.addActual(gameName);
        }
        if(version == NO_VERSION){
            tuple.add(new Field().setToNullActual(new Double(0).getClass()));
        }else{
            tuple.addActual(new Double(version));
        }
        if(leaderName == null){
            tuple.add(new Field().setToNullActual(new String().getClass()));
        }else{
            tuple.addActual(leaderName);
        }
        if(leaderID == NOT_SPECIFIED){
            tuple.add(new Field().setToNullActual(new Long(0).getClass()));
        }else{
            tuple.addActual(new Long(leaderID));
        }
        if(fieldID == NOT_SPECIFIED){
            tuple.add(new Field().setToNullActual(new Long(0).getClass()));
        }else{
            tuple.addActual(new Long(fieldID));
        }        
        if(tuplespace == null){
            tuple.add(new Field().setToNullActual(new String().getClass()));
        }else{
            tuple.addActual(tuplespace);
        }
        return tuple;
    }
    
    public String getLeaderName() {
        return leaderName;
    }
    
}
