/*
 * MeierNames.java
 *
 * Created on 3. Juni 2002, 19:42
 */

package casino.terms.game.meier;
 
/**
 *
 * @author  sven
 * @version 1.0
 */

import lights.adapters.*;
import lights.interfaces.*;

import lime.AgentID;

import casino.misc.MeierDice;

public class MeierTerms implements java.io.Serializable {
    
    public static final int PREDECESSOR_RESULT_START = -1;
    
    public static final int MEIER = Integer.MAX_VALUE;
    public static final int SECHSER_PASCH = Integer.MAX_VALUE-1;
    public static final int FUENFER_PASCH = Integer.MAX_VALUE-2;
    public static final int VIERER_PASCH = Integer.MAX_VALUE-3;
    public static final int DREIER_PASCH = Integer.MAX_VALUE-4;
    public static final int ZWEIER_PASCH = Integer.MAX_VALUE-5;
    public static final int EINER_PASCH = Integer.MAX_VALUE-6;
    
    public static final int FUENF_UND_SECHZIG = 65;
    public static final int VIER_UND_SECHZIG = 64;
    public static final int DREI_UND_SECHZIG = 63;
    public static final int ZWEI_UND_SECHZIG = 62;
    public static final int EIN_UND_SECHZIG = 61;
    
    public static final int VIER_UND_FUENFZIG = 54;
    public static final int DREI_UND_FUENFZIG = 53;
    public static final int ZWEI_UND_FUENFZIG = 52;
    public static final int EIN_UND_FUENFZIG = 51;
    
    public static final int DREI_UND_VIERZIG = 43;
    public static final int ZWEI_UND_VIERZIG = 42;
    public static final int EIN_UND_VIERZIG = 41;
    
    public static final int ZWEI_UND_DREISSIG = 32;
    public static final int EIN_UND_DREISSIG = 31;
    
    public static final String EINER_PASCH_STRING = "Einer Pasch";
    public static final String ZWEIER_PASCH_STRING = "Zweier Pasch";
    public static final String DREIER_PASCH_STRING = "Dreier Pasch";
    public static final String VIERER_PASCH_STRING = "Vierer Pasch";
    public static final String FUENFER_PASCH_STRING = "Fuenfer Pasch";
    public static final String SECHSER_PASCH_STRING = "Sechser Pasch";
    public static final String MEIER_STRING = "Meier";
    
    public static final int POINTS_LIE_DETECTED = 2;
    public static final int POINTS_LIED = -1;
    public static final int POINTS_FOR_UNSUCCESFULL_UNCOVERING = -1;
    public static final int POINTS_FOR_MISLEADING_SUCCESSOR = 3;
    
    public static final int ANMELDUNG_TUPLE_PLAYER_ID_POSITION= 0;
    public static final int ANMELDUNG_TUPLE_STRING_POSITION = 1;
    public static final String ANMELDUNGS_STRING = "Anmeldung";    
    
    public static final int ANMELDUNGS_BESTAETIGUNG_PLAYER_ID_POSITION = 0;
    public static final int ANMELDUNGS_BESTAETIGUNG_STRING_POSITION = 1;
    public static final int ANMELDUNGS_BESTAETIGUNG_BESTAETIGUNGS_POSITION = 2;
    public static final boolean ANMELDUNG_BESTAETIGT = true;
    public static final boolean ANMELDUNG_VERWEIGERT = false;
    
    public static final int CALLFORMOVE_TUPLE_PLAYER_ID_POSITION = 0;
    public static final int CALLFORMOVE_TUPLE_CALL_POSITION = 1;
    public static final int CALLFORMOVE_TUPLE_ACTION_POSITION = 2;
    public static final int CALLFORMOVE_TUPLE_PREDECESSOR_RESULT_POSITION = 3;
    public static final int CALLFORMOVE_TUPLE_COUNTER_POSITION = 4;
    public static final String CALLFORMOVE_STRING = "Move";
    public static final String CALLFORMOVE_ACTION_AFTER_UNCOVER_DICE = "Wuerfel";
    public static final String CALLFORMOVE_ACTION_AFTER_SUCCESSOR_UNCOVERED_DICE = "Wuerfel nach Luege";
    public static final String CALLFORMOVE_ACTION_INITIAL = "ChooseAction";
    public static final String CALLFORMOVE_ACTION_GAMEEND = "Game ended";

    
    public static final int MOVE_TUPLE_PLAYER_ID_POSITION = 0;
    public static final int MOVE_TUPLE_ACTION_POSITION = 1;
    public static final String THROWDICE_ACTION = "Wuerfel";
    public static final String DONT_TRUST_PREDECESSOR = "Aufdecken";
    
    public static final int INFORMATION_TUPLE_INFO_STRING_POSITION = 0;
    public static final int INFORMATION_TUPLE_ACTING_PLAYER_POSITION = 1;
    public static final int INFORMATION_TUPLE_PLAYER_ACTION_POSITION = 2;
    public static final int INFORMATION_TUPLE_PLAYER_ACTION_RESULT_POSITION = 3;
    public static final String INFORMATION_TUPLE_LABEL = "Info";
    public static final int UNCOVERING_DICE_SUCCESFULL = 1;
    public static final int UNCOVERING_DICE_UNSUCCESFULL = 0;
    
    public static final int POINT_ASSIGNMENT_TUPLE_PLAYER_ID_POSITION = 0;
    public static final int POINT_ASSIGNMENT_TUPLE_POINTS_POSITION = 1;
    
    public static final int END_GAME_PLAYER_ID_POSITION = 0;
    public static final int END_GAME_END_STRING_POSITION = 1;
    public static final String END_STRING = "Stop Game";
    
    public static final int DICE_TUPLE_PLAYER_ID_POSITION = 0;
    public static final int DICE_TUPLE_DICE_POSITION = 1;
    
    public static final int PROPAGATE_RESULT_TUPLE_RECEIVER_ID_POSITION = 0;
    public static final int PROPAGATE_RESULT_TUPLE_RESULT_POSITION = 1;
    public static final int PROPAGATE_RESULT_TUPLE_SENDER_ID_POSITION = 2;
    
    public static final int PLAYERS_TUPLE_PLAYERS_POSITION = 0;
    
    public static final int SHOW_GUI_TUPLE_PLAYERID_POSITION = 0;
    public static final int SHOW_GUI_TUPLE_SHOW_STRING_POSITION = 1;
    public static final int SHOW_GUI_TUPLE_FLAG_POSITION = 2;
    
    public static final String SHOW_GUI = "show gui";
    
    //public static MeierTerms MeierTermsSingleton = null;
    
    public static final int LEADERID_TUPLE_ID_POSITION = 0;
    
    public MeierTerms() {
        /*if (MeierTermsSingleton == null){
            MeierTermsSingleton = this;
        }else{
            throw new Exception("MeierTerms existieren schon im System");
        }*/
    }
    
    public ITuple generateLeaderIDTuple(){
        ITuple agentID = new Tuple();
        agentID.addFormal(AgentID.class);
        return agentID;
    }
        
    /*public static MeierTerms getMeierTermsSingleton(){
        if (MeierTermsSingleton == null){
            try {
                MeierTermsSingleton = new MeierTerms();
            }catch(Exception e){
                e.printStackTrace();
            }
        }
        return MeierTermsSingleton;
    }*/
    
    public ITuple generateLogonTuple(){
        
        Field anmeldungField = new Field();
        anmeldungField.setToActual(ANMELDUNGS_STRING);

        ITuple anmeldungTemplate = new Tuple();
        anmeldungTemplate.addFormal(Long.class);
        anmeldungTemplate.addFormal(String.class);
        anmeldungTemplate.set(anmeldungField, this.ANMELDUNG_TUPLE_STRING_POSITION);
        
        return anmeldungTemplate;
    }
    
    public ITuple generateLogonAcknowledgementTuple(){
        
        Field anmeldungField = new Field();
        String logon = ANMELDUNGS_STRING;
        anmeldungField.setToActual(logon);

        ITuple anmeldungsBestaetigungTemplate = new Tuple();
        anmeldungsBestaetigungTemplate.addFormal(Long.class);
        anmeldungsBestaetigungTemplate.addFormal(String.class);
        anmeldungsBestaetigungTemplate.set(anmeldungField, this.ANMELDUNGS_BESTAETIGUNG_STRING_POSITION);
        anmeldungsBestaetigungTemplate.addFormal(Boolean.class);
        
        return anmeldungsBestaetigungTemplate;
    }

    public ITuple generateCallForMoveTuple() {
        ITuple callForMove = new Tuple();
        //ID des aufzufordernden Spielers
        callForMove.addFormal(Long.class);
        //String "Move"
        callForMove.addFormal(String.class);
        //Art des zugs
        callForMove.addFormal(String.class);
        //Ergebnis des Zugs des Vorgngers
        callForMove.addFormal(Integer.class);
        IField call = new Field();
        call.setToActual(CALLFORMOVE_STRING);
        callForMove.set(call, CALLFORMOVE_TUPLE_CALL_POSITION);
        callForMove.addFormal(Integer.class);
        return callForMove;
        
    }
    
    public ITuple generateMoveTuple(){
        ITuple moveTuple = new Tuple();
        //ID des GameLeaders
        moveTuple.addFormal(Long.class);
        //Zug der ausgefhrt werden soll
        moveTuple.addFormal(String.class);
        return moveTuple;
    }
    
    public ITuple generateInformationTuple(){
        ITuple info = new Tuple();
        info.addFormal(String.class);
        IField infoLabel = new Field();
        infoLabel.setToActual(INFORMATION_TUPLE_LABEL);
        info.set(infoLabel, this.INFORMATION_TUPLE_INFO_STRING_POSITION);
        //ID des Spielers, der die Aktion durchgefhrt hat
        info.addFormal(Long.class);
        //Aktion des Spielers
        info.addFormal(String.class);
        //Ergebnis der Aktion
        info.addFormal(Integer.class);
        return info;
    }
    
    public ITuple generateDiceTuple(){
        
        ITuple dice = new Tuple();
        //ID des Empfngers
        dice.addFormal(Long.class);
        //Der Wrfel
        dice.addFormal(MeierDice.class);
        return dice;
        
    }
    
    public ITuple generatePointAssignmentTuple(){
        ITuple pointAssignment = new Tuple();
        //ID des empfngers
        pointAssignment.addFormal(Long.class);
        //Anzahl der Punkte
        pointAssignment.addFormal(Integer.class);
        return pointAssignment;
    }
    
    public ITuple generateEndGameTuple(){
        ITuple end = new Tuple();
        //ID des Empfngers
        end.addFormal(Long.class);
        //String der besagt, dass das Spiel beendet ist
        end.addFormal(String.class);
        IField string = new Field();
        string.setToActual(END_STRING);
        end.set(string, END_GAME_END_STRING_POSITION);
        return end;
    }
    
    public ITuple generatePropagateResultTuple(){
        ITuple propagation = new Tuple();
        //ID des Empfngers
        propagation.addFormal(Long.class);
        //Aussage des Senders
        propagation.addFormal(Integer.class);
        //ID des Senders 
        propagation.addFormal(Long.class);
        return propagation;
    }
    
    public ITuple generatePlayersTuple(){
        ITuple players = new Tuple();
        players.addFormal(java.util.Vector.class);
        return players;
    }
    
    public ITuple generateShowGUITuple(){
        ITuple showGUI = new Tuple();
        showGUI.addFormal(Long.class);
        showGUI.addFormal(String.class);
        IField showString = new Field();
        showString.setToActual(this.SHOW_GUI);
        showGUI.set(showString, this.SHOW_GUI_TUPLE_SHOW_STRING_POSITION);
        showGUI.addFormal(Boolean.class);
        return showGUI;
    }
    
    public static String diceResultToString(int result){
        if (result >= EINER_PASCH){
                if (result == EINER_PASCH) return EINER_PASCH_STRING;
                if (result == ZWEIER_PASCH) return ZWEIER_PASCH_STRING;
                if (result == DREIER_PASCH) return DREIER_PASCH_STRING;
                if (result == VIERER_PASCH) return VIERER_PASCH_STRING;
                if (result == FUENFER_PASCH) return FUENFER_PASCH_STRING;
                if (result == SECHSER_PASCH) return SECHSER_PASCH_STRING;
                if (result == MEIER) return MEIER_STRING;
        }
        return Integer.toString(result);
    }
    
    public static int stringToDiceResult(String result){
        if (result == EINER_PASCH_STRING) return EINER_PASCH;
        if (result == ZWEIER_PASCH_STRING) return ZWEIER_PASCH;
        if (result == DREIER_PASCH_STRING) return DREIER_PASCH;
        if (result == VIERER_PASCH_STRING) return VIERER_PASCH;
        if (result == FUENFER_PASCH_STRING) return FUENFER_PASCH;
        if (result == SECHSER_PASCH_STRING) return SECHSER_PASCH;
        if (result == MEIER_STRING) return MEIER;
        return Integer.parseInt(result);
    }
    
    public static java.util.Vector giveAllPossibleMeierResults(){
        java.util.Vector meierResults = new java.util.Vector();
        meierResults.add(new Integer(EIN_UND_DREISSIG));
        meierResults.add(new Integer(ZWEI_UND_DREISSIG));
        meierResults.add(new Integer(EIN_UND_VIERZIG));
        meierResults.add(new Integer(ZWEI_UND_VIERZIG));
        meierResults.add(new Integer(DREI_UND_VIERZIG));
        meierResults.add(new Integer(EIN_UND_FUENFZIG));
        meierResults.add(new Integer(ZWEI_UND_FUENFZIG));
        meierResults.add(new Integer(DREI_UND_FUENFZIG));
        meierResults.add(new Integer(VIER_UND_FUENFZIG));
        meierResults.add(new Integer(EIN_UND_SECHZIG));
        meierResults.add(new Integer(ZWEI_UND_SECHZIG));
        meierResults.add(new Integer(DREI_UND_SECHZIG));
        meierResults.add(new Integer(VIER_UND_SECHZIG));
        meierResults.add(new Integer(FUENF_UND_SECHZIG));
        meierResults.add(new Integer(EINER_PASCH));
        meierResults.add(new Integer(ZWEIER_PASCH));
        meierResults.add(new Integer(DREIER_PASCH));
        meierResults.add(new Integer(VIERER_PASCH));
        meierResults.add(new Integer(FUENFER_PASCH));
        meierResults.add(new Integer(SECHSER_PASCH));
        meierResults.add(new Integer(MEIER));
        return meierResults;
    }
}