package casino.test;

/*
 * LookupAdministrator.java
 *
 * Created on 22. Juni 2002, 00:19
 */

import lime.*;
import lights.interfaces.*;
import casino.plugins.lookup.*;
import casino.plugins.lookup.version1_0.*;
import casino.plugins.*;

/**
 *
 * @author  jens
 * @version 
 */
public class EnvironmentChecker extends StationaryAgent{
    
    protected static final double version = 1.0;
    protected boolean active = true;
    protected long nextID = 1;
    
    /** Creates new LookupAdministrator */
    public EnvironmentChecker() {
        
    }

    public void run() {
        
        LimeTupleSpace lookup = null;
        LimeTupleSpace whiteboard = null;
        try{
            lookup = new LimeTupleSpace(CommonPluginTerms.LOOKUP_TS_VERSION_1_0);
            whiteboard = new LimeTupleSpace(CommonPluginTerms.WHITEBOARD_TS_VERSION_1_0);
            System.out.println("Tuplespace erstellt!");
            if((lookup != null) && (whiteboard != null)){ 
                lookup.setShared(true);
                whiteboard.setShared(true);
                System.out.println("Lookup-Tuplespace shared: "+lookup.isShared());
                System.out.println("Whiteboard-Tuplespace shared: "+whiteboard.isShared());
                //LimeServer.getServer().declareLeader();
                LimeServer.getServer().engage();
                System.out.println("Host engaged "+ LimeServer.getServer().isEngaged());
                System.out.println("Teste Lookup");
                System.out.println("============");                
                VersionNachricht vn = new VersionNachricht(-5);
                ITuple tuple = lookup.rd(vn.getRequestTuple());
                VersionNachricht va = new VersionNachricht(tuple);
                System.out.println("Lookup-Version: "+va.getVersion());
                LULookupNachricht LuNa = new LULookupNachricht(null,CommonPluginTerms.LOOKUP_TS_VERSION_1_0,-6);
                LULookupNachricht lookupNachricht = new LULookupNachricht(lookup.rd(LuNa.getRequestTuple()));
                System.out.println("Tuplespace: "+lookupNachricht.getTuplespace().toString());
                System.out.println("Admin-ID: "+lookupNachricht.getAdminID());
                System.out.println("Location: "+lookupNachricht.getPlace().toString());
                HostLocation lookupHost = lookupNachricht.getPlace();
                LUAdministratorNachricht administrators = new LUAdministratorNachricht(null,-42,null,null);
                ITuple[] adminTuples = lookup.rdg(lookupHost,AgentLocation.UNSPECIFIED,administrators.getRequestTuple());
                System.out.println("Administratoren: ");                
                for(int i = 0;i < adminTuples.length;i++){
                    LUAdministratorNachricht admin = new LUAdministratorNachricht(adminTuples[i]);
                    System.out.println("      "+admin.getAdministrationObject()+" "+admin.getID()+" "+admin.getName()+" "+admin.getPlace()+" ::::: ");
                }
                System.out.println();
                LUWhiteboardNachricht whbona = new LUWhiteboardNachricht(-5,null,null,-42);
                LUWhiteboardNachricht wn = new LUWhiteboardNachricht(lookup.rd(whbona.getRequestTuple()));
                System.out.println("Whiteboard: "+wn.getAdminID()+" "+wn.getPlace()+" "+wn.getVersion()+" "+wn.getTuplespace());
                System.out.println("Teste Whiteboard");
                System.out.println("================");
                VersionNachricht wbv = new VersionNachricht(-42);
                VersionNachricht wbVersion = new VersionNachricht(whiteboard.rd(wbv.getRequestTuple()));
                System.out.println("Version: "+wbVersion.getVersion());
                System.out.println();
            }
        }catch(Exception e){e.printStackTrace();System.out.println("Lookup-Admin-Fehler");}
        System.out.println("Ende");
    }
    
    public void deactivate() {
        active = false;
    }
    
}
