/**
 * An event generated by the Interactor.
 *
 * @author Jason Ginchereau
 * @version 11/12/99
 */
public class InteractorEvent extends java.util.EventObject {
  public static final int FEATURE_UPDATED = 1;

  /**
   * Creates a new FEATURE_UPDATED InteractorEvent.
   */
  public InteractorEvent(Interactor source, String tag,
                         Feature updatedFeature) {
    this(source, FEATURE_UPDATED);
    this.tag = tag;
    this.updatedFeature = updatedFeature;
  }

  /**
   * Creates a new InteractorEvent.
   * NOTE: this constructor is for future expansion purposes.
   */
  public InteractorEvent(Interactor source, int id) {
    super(source);
    this.id = id;
  }

  /**
   * Gets the Interactor that generated this event.
   */
  public Interactor getInteractor() {
    return (Interactor) getSource();
  }

  /**
   * Gets the type of this InteractorEvent, as one of the static final
   * values defined by the InteractorEvent class.
   */
  public int getID() {
    return id;
  }

  /**
   * Gets the Feature whose update caused this event.
   */
  public Feature getFeature() {
    return updatedFeature;
  }

  /**
   * Gets a string that is the type of Feature of this event.
   */
  public String getTag() {
    return tag;
  }

  private int     id;
  private String  tag;
  private Feature updatedFeature;
}

