
/**
 * An event generated by the MapViewer that indicates the viewing
 * window has changed, so more information is needed.
 *
 * @author Jason Ginchereau
 * @version 11/12/99
 */
public class MapWindowEvent extends java.util.EventObject {

  /**
   * Creates a new MapWindowEvent.
   */
  public MapWindowEvent(MapViewer source, java.awt.Shape newWindow) {
    super(source);
    this.window = newWindow;
  }

  /**
   * Gets the MapViewer that generated this event.
   */
  public MapViewer getMapViewer() {
    return (MapViewer) getSource();
  }

  /**
   * Gets the new viewing window on the map.
   */
  public java.awt.Shape getWindow() {
    return window;
  }

  private java.awt.Shape window;
}

